﻿'!********************************************
'! FixedCode
'! Do not change the source code of this block. 
'!********************************************
Option Executable
'!
'! TcpNormal, UdpNormal, UdpNormal2, SerialNormal, SerialNormal2
'!
*StringCommand

    '! Initialize
    GoSub *Initialize
    
    IF CommandLine$ = "" Then Return

    Try
        '! CmdNo&
        CommandString$ = Piece$(CommandLine$, CommandDelimiter$, 1,1)
        GoSub *GetCommandNo

        ArgmentsLine$ = Piece$(CommandLine$, CommandDelimiter$, 2,1024)
        If ArgmentsLine$ = "" Then
          ArgmentsLine$ = " "
        EndIf

        Delimiter1Count& = 0
        GoSub *GetDelimiter1Count

        If Delimiter1Count& Mod 2 <> 0 Then
           ArgmentsLine$ = ArgmentsLine$ + CommandDelimiter1$
           Delimiter1Count& = Delimiter1Count& + 1
        EndIf

        '! Argments
        ArgmentsLength& = 0
        ArgumentsLength& = ArgmentsLength&

        For I& = 1 To Delimiter1Count& + 1
            SubArgmentsLine$ = Piece$(ArgmentsLine$, CommandDelimiter1$, I&, I&)
            If I& MOD 2 <> 0 Then
              DelimiterCount& = 0
              GoSub *GetDelimiterCount

              If SubArgmentsLine$ = "" Then
                TmpSubArgmentsLine$ = " "
              Else
                TmpSubArgmentsLine$ = SubArgmentsLine$
              EndIf

              For J& = 1 To DelimiterCount& + 1
                TMPSTR$ = Piece$(TmpSubArgmentsLine$, CommandDelimiter$, J&, J&)
                If J& = 1 Then
                  If TMPSTR$ <> SubArgmentsLine$ Then
                    ArgmentString$(ArgmentsLength&) = TMPSTROLD$ + TMPSTR$
                    GoSub *SetArgument
                    TMPSTROLD$ = ""
                  Else
                    TMPSTROLD$ = TMPSTROLD$ + TMPSTR$
                  EndIf
                ElseIf J& <> DelimiterCount& + 1 Then
                  ArgmentString$(ArgmentsLength&) = TMPSTR$
                  GoSub *SetArgument
                  TMPSTROLD$ = ""
                Else
                  TMPSTROLD$ = TMPSTROLD$ + TMPSTR$
                EndIf
              Next
            ElseIf SubArgmentsLine$ <> "" Then
              TMPSTROLD$ = TMPSTROLD$ + SubArgmentsLine$
            EndIf
        Next
    
        If TMPSTROLD$ <> "" Then
          ArgmentString$(ArgmentsLength&) = TMPSTROLD$
          GoSub *SetArgument
          TMPSTROLD$ = ""
        EndIf
    Catch
        CommandResponse& = -1
        Return
    End Try
    
    '! No Command
    If CmdNo& < 0 Then Return
    
    '! Not Active
    If ActiveTable&(CmdNo&) = False Then Return
      
    ' Set execute flag
    CommandExecute& = True
    
    ' MeasureStop
    If MeasureStopTable&(CmdNo&) = True Then
        MeasureStop
    Endif

    ' Execute command
    ' call macro function
    GoSub *FunctionCall  

    ' MeasureStart
    If MeasureStopTable&(CmdNo&) = True Then
        MeasureStart
    Endif

    Try
        ' Set result code
        CommandResponse& = ResponseCode&
    
        ' Send result data
        If (CommandExecute& = True) Then
            If(ResponseString$ <> "") Then
                SendString IoIdent$, ResponseString$
            Endif
        Endif

    Catch
        CommandResponse& = -1
        Return
    End Try
   
Return


'!
'! UdpPlcLink, UdpPlcLinkM
'!
*PlcLinkCommand

    ' Initialize
    GoSub *Initialize

    ' CommandNo
    CmdNo& = CommandCode&

    ' response array
    Dim plcSndData&(6)
    
    ' No Command
    If CmdNo& < 0 Then Return
    If CmdNo& >= CommandCountMax& Then Return 
    
    ' Not Active
    If ActiveTable&(CmdNo&) = False Then Return
    
    ' Get settings
    GetSystemData IoIdent$, "commandArea", commandArea&
    GetSystemData IoIdent$, "commandMemoryAddress", commandMemoryAddress&
    GetSystemData IoIdent$, "responseArea", responseArea&
    GetSystemData IoIdent$, "responseMemoryAddress", responseMemoryAddress&
    
    ' Get command parameters from plc memory
    Try
        Dim plcRcvData&(5)
        ReadPlcMemory IoIdent$, commandArea&, commandMemoryAddress& + 4, 12, plcRcvData&()
        For I& = 0 To 5
            GetPlcData IoIdent$, plcRcvData&(), I& * 4, 4, ArgmentValue#(I&)
            ArgumentValue#(I&) = ArgmentValue#(I&)
        Next

        Dim plcRcvStrData$(23)
        strCount& = -1
        isEndFlg& = 1
        For J& = 0 To 23
            GetPlcData IoIdent$, plcRcvData&(), J&, 1, plcRcvStrData$(J&)
            If plcRcvStrData$(J&) <> Chr$(0) And isEndFlg& = 1 Then
                strCount& = strCount& + 1
                ArgmentString$(strCount&) = ArgmentString$(strCount&) + plcRcvStrData$(J&)
                ArgumentString$(strCount&) = ArgmentString$(strCount&)
                isEndFlg& = 0
            ElseIf plcRcvStrData$(J&) <> Chr$(0) And isEndFlg& = 0 Then
                ArgmentString$(strCount&) = ArgmentString$(strCount&) + plcRcvStrData$(J&)
                ArgumentString$(strCount&) = ArgmentString$(strCount&)
            ElseIf plcRcvStrData$(J&) = Chr$(0) And isEndFlg& = 0 Then
                isEndFlg& = 1
            EndIf
        Next

        ArgmentsLength& = 6
        ArgumentsLength& = ArgmentsLength&
    Catch
      SetPlcData IoIdent$, plcSndData&(), 4, 4, -1
      WritePlcMemory IoIdent$, responseArea&, responseMemoryAddress& + 2, 14, plcSndData&()
      Return
    End Try
    
    ' Set execute flag
    CommandExecute& = True
    
    ' MeasureStop
    If MeasureStopTable&(CmdNo&) = True Then
        MeasureStop
    Endif

    ' Execute command
    ' call macro function
    GoSub *FunctionCall

    ' MeasureStart
    If MeasureStopTable&(CmdNo&) = True Then
        MeasureStart
    Endif    
    
    Try
        ' Make response array
        SetPlcData IoIdent$, plcSndData&(), 0, 4, CommandCode&
        SetPlcData IoIdent$, plcSndData&(), 4, 4, ResponseCode&
        For I& = 0 To 4
            SetPlcData IoIdent$, plcSndData&(), 8 + I& * 4, 4, ResponseValue&(I&)
        Next
    
        ' Set response to plc memory
        WritePlcMemory IoIdent$, responseArea&, responseMemoryAddress& + 2, 14, plcSndData&()
    
    Catch
      SetPlcData IoIdent$, plcSndData&(), 4, 4, -1
      WritePlcMemory IoIdent$, responseArea&, responseMemoryAddress& + 2, 14, plcSndData&()
      Return
    End Try    
    
Return

'!
'! Parallel
'!
*ParallelCommand

    ' Initialize
    GoSub *Initialize

    Try
        ' CommandNo (Remove DI7 bit)
        CmdNo& = BitPattern& - 128
        AddGlobalData "ParallelDIOffset", 0
        GetGlobalData "ParallelDIOffset", paraOffset&
        CmdNo& = CmdNo& + paraOffset&
    Catch
        CommandResponse& = -1
        Return
    End Try
    
    ArgmentsLength&=0
    ArgumentsLength& = ArgmentsLength&
    
    ' No Command
    If CmdNo& < 0 Then Return
    If CmdNo& >= CommandCountMax& Then Return 
    
    ' Not Active
    If ActiveTable&(CmdNo&) = False Then Return
       
    ' Set execute flag
    CommandExecute& = True
    
    ' MeasureStop
    If MeasureStopTable&(CmdNo&) = True Then
        MeasureStop
    Endif

    ' Execute command

    ' call macro function
    GoSub *FunctionCall

    ' MeasureStart
    If MeasureStopTable&(CmdNo&) = True Then
        MeasureStart
    Endif
    
    ' Set result code
    CommandResponse& = ResponseCode&
    
Return


'!
'! EtherNetIP, EtherCAT
'!
*FieldbusCommand

    ' Initialize
    GoSub *Initialize
    
    Try
        ' CommandNo
        CmdNo& = CommandData&(0)
        CommandResponse&(0) = CommandData&(0)

        ' Argments
        ArgmentValue#(0) = CommandData&(1)
        ArgmentValue#(1) = CommandData&(2)
        ArgmentValue#(2) = CommandData&(3)
        ArgumentValue#(0) = ArgmentValue#(0)
        ArgumentValue#(1) = ArgmentValue#(1)
        ArgumentValue#(2) = ArgmentValue#(2)

        Dim plcRcvStrData$(11)
        lowBytes& = 0
        highBytes& = 0

        For I& = 0 To 2
          If ArgmentValue#(I&) >= 0 Then
            lowBytes& = ArgmentValue#(I&) mod 65536
            highBytes& = (ArgmentValue#(I&) - lowBytes&) / 65536
          Else
            lowBytes& = (2147483647 + ArgmentValue#(I&) + 1) MOD 65536
            highBytes& = (((2147483647 + ArgmentValue#(I&) + 1) - lowBytes&) /65536 ) + 32768   
          EndIf
          plcRcvStrData$(I&*4 + 1) = Chr$(lowBytes& mod 256)
          plcRcvStrData$(I&*4) = Chr$((lowBytes& - (lowBytes& mod 256)) / 256)   
          plcRcvStrData$(I&*4 + 3) = Chr$(highBytes& mod 256)
          plcRcvStrData$(I&*4 + 2) = Chr$((highBytes& - (highBytes& mod 256))/ 256)
        Next

        strCount& = -1
        isEndFlg& = 1
        For J& = 0 To 11
          If plcRcvStrData$(J&) <> Chr$(0) And isEndFlg& = 1 Then
             strCount& = strCount& + 1
             ArgmentString$(strCount&) = ArgmentString$(strCount&) + plcRcvStrData$(J&)
             ArgumentString$(strCount&) = ArgmentString$(strCount&)
             isEndFlg& = 0
          ElseIf plcRcvStrData$(J&) <> Chr$(0) And isEndFlg& = 0 Then
             ArgmentString$(strCount&) = ArgmentString$(strCount&) + plcRcvStrData$(J&)
             ArgumentString$(strCount&) = ArgmentString$(strCount&)
          ElseIf plcRcvStrData$(J&) = Chr$(0) And isEndFlg& = 0 Then
             isEndFlg& = 1
          EndIf
        Next

        ArgmentsLength& = 3
        ArgumentsLength& = ArgmentsLength&
    Catch
        CommandResponse&(1) = -1
        Return
    End Try
    
    ' No Command
    If CmdNo& < 0 Then Return
    If CmdNo& >= CommandCountMax& Then Return 
    
    ' Not Active
    If ActiveTable&(CmdNo&) = False Then Return
       
    ' Set execute flag
    CommandExecute& = True
    
    ' MeasureStop
    If MeasureStopTable&(CmdNo&) = True Then
        MeasureStop
    Endif

    ' Execute command
    ' call macro function
    GoSub *FunctionCall   

    ' MeasureStart
    If MeasureStopTable&(CmdNo&) = True Then
        MeasureStart
    Endif
    
    ' Set reult
    CommandResponse&(0) = CommandData&(0)
    CommandResponse&(1) = ResponseCode&
    CommandResponse&(2) = ResponseValue&(0)
    
Return


*Initialize

    ' Result
    CommandExecute& = False
    ResponseCode& = 0
    ResponseString$ = ""
    Dim ResponseValue&(4)
    
    
    ' Argments
    Dim ArgmentString$(ArgmentCountMax& - 1)
    Dim ArgumentString$(ArgmentCountMax& - 1)
    Dim ArgmentValue#(ArgmentCountMax& - 1)
    Dim ArgumentValue#(ArgmentCountMax& - 1)
    For I& = 0 To ArgmentCountMax& - 1
        ArgmentString$(I&) = ""
        ArgumentString$(I&) = ArgmentString$(I&)
        ArgmentValue#(I&) = 0.0
        ArgumentValue#(I&) = ArgmentValue#(I&)
    Next

    TMPSTR$ = ""
    TMPSTROLD$ = ""
    SubArgmentsLine$ = ""
    ArgmentsLine$ = ""

Return

*GetCommandNo
    CmdNo& = -1
    For I& = 0 To CommandCountMax& - 1
        If (UCase$(CommandString$) = UCase$(CMD$(I&))) Then
            CmdNo& = I&
        Endif
    Next
Return


*FunctionCall
Try

    Select CmdNo&
    Case 0
        GoSub *CMD_FUNC0000
    Case 1
        GoSub *CMD_FUNC0001
    Case 2
        GoSub *CMD_FUNC0002
    Case 3
        GoSub *CMD_FUNC0003
    Case 4
        GoSub *CMD_FUNC0004
    Case 5
        GoSub *CMD_FUNC0005
    Case 6
        GoSub *CMD_FUNC0006
    Case 7
        GoSub *CMD_FUNC0007
    Case 8
        GoSub *CMD_FUNC0008
    Case 9
        GoSub *CMD_FUNC0009
    Case 10
        GoSub *CMD_FUNC0010
    Case 11
        GoSub *CMD_FUNC0011
    Case 12
        GoSub *CMD_FUNC0012
    Case 13
        GoSub *CMD_FUNC0013
    Case 14
        GoSub *CMD_FUNC0014
    Case 15
        GoSub *CMD_FUNC0015
    Case 16
        GoSub *CMD_FUNC0016
    Case 17
        GoSub *CMD_FUNC0017
    Case 18
        GoSub *CMD_FUNC0018
    Case 19
        GoSub *CMD_FUNC0019
    Case 20
        GoSub *CMD_FUNC0020
    Case 21
        GoSub *CMD_FUNC0021
    Case 22
        GoSub *CMD_FUNC0022
    Case 23
        GoSub *CMD_FUNC0023
    Case 24
        GoSub *CMD_FUNC0024
    Case 25
        GoSub *CMD_FUNC0025
    Case 26
        GoSub *CMD_FUNC0026
    Case 27
        GoSub *CMD_FUNC0027
    Case 28
        GoSub *CMD_FUNC0028
    Case 29
        GoSub *CMD_FUNC0029
    Case 30
        GoSub *CMD_FUNC0030
    Case 31
        GoSub *CMD_FUNC0031
    Case 32
        GoSub *CMD_FUNC0032
    Case 33
        GoSub *CMD_FUNC0033
    Case 34
        GoSub *CMD_FUNC0034
    Case 35
        GoSub *CMD_FUNC0035
    Case 36
        GoSub *CMD_FUNC0036
    Case 37
        GoSub *CMD_FUNC0037
    Case 38
        GoSub *CMD_FUNC0038
    Case 39
        GoSub *CMD_FUNC0039
    Case 40
        GoSub *CMD_FUNC0040
    Case 41
        GoSub *CMD_FUNC0041
    Case 42
        GoSub *CMD_FUNC0042
    Case 43
        GoSub *CMD_FUNC0043
    Case 44
        GoSub *CMD_FUNC0044
    Case 45
        GoSub *CMD_FUNC0045
    Case 46
        GoSub *CMD_FUNC0046
    Case 47
        GoSub *CMD_FUNC0047
    Case 48
        GoSub *CMD_FUNC0048
    Case 49
        GoSub *CMD_FUNC0049
    Case 50
        GoSub *CMD_FUNC0050
    Case 51
        GoSub *CMD_FUNC0051
    Case 52
        GoSub *CMD_FUNC0052
    Case 53
        GoSub *CMD_FUNC0053
    Case 54
        GoSub *CMD_FUNC0054
    Case 55
        GoSub *CMD_FUNC0055
    Case 56
        GoSub *CMD_FUNC0056
    Case 57
        GoSub *CMD_FUNC0057
    Case 58
        GoSub *CMD_FUNC0058
    Case 59
        GoSub *CMD_FUNC0059
    Case 60
        GoSub *CMD_FUNC0060
    Case 61
        GoSub *CMD_FUNC0061
    Case 62
        GoSub *CMD_FUNC0062
    Case 63
        GoSub *CMD_FUNC0063
    Case 64
        GoSub *CMD_FUNC0064
    Case 65
        GoSub *CMD_FUNC0065
    Case 66
        GoSub *CMD_FUNC0066
    Case 67
        GoSub *CMD_FUNC0067
    Case 68
        GoSub *CMD_FUNC0068
    Case 69
        GoSub *CMD_FUNC0069
    Case 70
        GoSub *CMD_FUNC0070
    Case 71
        GoSub *CMD_FUNC0071
    Case 72
        GoSub *CMD_FUNC0072
    Case 73
        GoSub *CMD_FUNC0073
    Case 74
        GoSub *CMD_FUNC0074
    Case 75
        GoSub *CMD_FUNC0075
    Case 76
        GoSub *CMD_FUNC0076
    Case 77
        GoSub *CMD_FUNC0077
    Case 78
        GoSub *CMD_FUNC0078
    Case 79
        GoSub *CMD_FUNC0079
    Case 80
        GoSub *CMD_FUNC0080
    Case 81
        GoSub *CMD_FUNC0081
    Case 82
        GoSub *CMD_FUNC0082
    Case 83
        GoSub *CMD_FUNC0083
    Case 84
        GoSub *CMD_FUNC0084
    Case 85
        GoSub *CMD_FUNC0085
    Case 86
        GoSub *CMD_FUNC0086
    Case 87
        GoSub *CMD_FUNC0087
    Case 88
        GoSub *CMD_FUNC0088
    Case 89
        GoSub *CMD_FUNC0089
    Case 90
        GoSub *CMD_FUNC0090
    Case 91
        GoSub *CMD_FUNC0091
    Case 92
        GoSub *CMD_FUNC0092
    Case 93
        GoSub *CMD_FUNC0093
    Case 94
        GoSub *CMD_FUNC0094
    Case 95
        GoSub *CMD_FUNC0095
    Case 96
        GoSub *CMD_FUNC0096
    Case 97
        GoSub *CMD_FUNC0097
    Case 98
        GoSub *CMD_FUNC0098
    Case 99
        GoSub *CMD_FUNC0099
    Case 100
        GoSub *CMD_FUNC0100
    Case 101
        GoSub *CMD_FUNC0101
    Case 102
        GoSub *CMD_FUNC0102
    Case 103
        GoSub *CMD_FUNC0103
    Case 104
        GoSub *CMD_FUNC0104
    Case 105
        GoSub *CMD_FUNC0105
    Case 106
        GoSub *CMD_FUNC0106
    Case 107
        GoSub *CMD_FUNC0107
    Case 108
        GoSub *CMD_FUNC0108
    Case 109
        GoSub *CMD_FUNC0109
    Case 110
        GoSub *CMD_FUNC0110
    Case 111
        GoSub *CMD_FUNC0111
    Case 112
        GoSub *CMD_FUNC0112
    Case 113
        GoSub *CMD_FUNC0113
    Case 114
        GoSub *CMD_FUNC0114
    Case 115
        GoSub *CMD_FUNC0115
    Case 116
        GoSub *CMD_FUNC0116
    Case 117
        GoSub *CMD_FUNC0117
    Case 118
        GoSub *CMD_FUNC0118
    Case 119
        GoSub *CMD_FUNC0119
    Case 120
        GoSub *CMD_FUNC0120
    Case 121
        GoSub *CMD_FUNC0121
    Case 122
        GoSub *CMD_FUNC0122
    Case 123
        GoSub *CMD_FUNC0123
    Case 124
        GoSub *CMD_FUNC0124
    Case 125
        GoSub *CMD_FUNC0125
    Case 126
        GoSub *CMD_FUNC0126
    Case 127
        GoSub *CMD_FUNC0127
    Case 128
        GoSub *CMD_FUNC0128
    Case 129
        GoSub *CMD_FUNC0129
    Case 130
        GoSub *CMD_FUNC0130
    Case 131
        GoSub *CMD_FUNC0131
    Case 132
        GoSub *CMD_FUNC0132
    Case 133
        GoSub *CMD_FUNC0133
    Case 134
        GoSub *CMD_FUNC0134
    Case 135
        GoSub *CMD_FUNC0135
    Case 136
        GoSub *CMD_FUNC0136
    Case 137
        GoSub *CMD_FUNC0137
    Case 138
        GoSub *CMD_FUNC0138
    Case 139
        GoSub *CMD_FUNC0139
    Case 140
        GoSub *CMD_FUNC0140
    Case 141
        GoSub *CMD_FUNC0141
    Case 142
        GoSub *CMD_FUNC0142
    Case 143
        GoSub *CMD_FUNC0143
    Case 144
        GoSub *CMD_FUNC0144
    Case 145
        GoSub *CMD_FUNC0145
    Case 146
        GoSub *CMD_FUNC0146
    Case 147
        GoSub *CMD_FUNC0147
    Case 148
        GoSub *CMD_FUNC0148
    Case 149
        GoSub *CMD_FUNC0149
    Case 150
        GoSub *CMD_FUNC0150
    Case 151
        GoSub *CMD_FUNC0151
    Case 152
        GoSub *CMD_FUNC0152
    Case 153
        GoSub *CMD_FUNC0153
    Case 154
        GoSub *CMD_FUNC0154
    Case 155
        GoSub *CMD_FUNC0155
    Case 156
        GoSub *CMD_FUNC0156
    Case 157
        GoSub *CMD_FUNC0157
    Case 158
        GoSub *CMD_FUNC0158
    Case 159
        GoSub *CMD_FUNC0159
    Case 160
        GoSub *CMD_FUNC0160
    Case 161
        GoSub *CMD_FUNC0161
    Case 162
        GoSub *CMD_FUNC0162
    Case 163
        GoSub *CMD_FUNC0163
    Case 164
        GoSub *CMD_FUNC0164
    Case 165
        GoSub *CMD_FUNC0165
    Case 166
        GoSub *CMD_FUNC0166
    Case 167
        GoSub *CMD_FUNC0167
    Case 168
        GoSub *CMD_FUNC0168
    Case 169
        GoSub *CMD_FUNC0169
    Case 170
        GoSub *CMD_FUNC0170
    Case 171
        GoSub *CMD_FUNC0171
    Case 172
        GoSub *CMD_FUNC0172
    Case 173
        GoSub *CMD_FUNC0173
    Case 174
        GoSub *CMD_FUNC0174
    Case 175
        GoSub *CMD_FUNC0175
    Case 176
        GoSub *CMD_FUNC0176
    Case 177
        GoSub *CMD_FUNC0177
    Case 178
        GoSub *CMD_FUNC0178
    Case 179
        GoSub *CMD_FUNC0179
    Case 180
        GoSub *CMD_FUNC0180
    Case 181
        GoSub *CMD_FUNC0181
    Case 182
        GoSub *CMD_FUNC0182
    Case 183
        GoSub *CMD_FUNC0183
    Case 184
        GoSub *CMD_FUNC0184
    Case 185
        GoSub *CMD_FUNC0185
    Case 186
        GoSub *CMD_FUNC0186
    Case 187
        GoSub *CMD_FUNC0187
    Case 188
        GoSub *CMD_FUNC0188
    Case 189
        GoSub *CMD_FUNC0189
    Case 190
        GoSub *CMD_FUNC0190
    Case 191
        GoSub *CMD_FUNC0191
    Case 192
        GoSub *CMD_FUNC0192
    Case 193
        GoSub *CMD_FUNC0193
    Case 194
        GoSub *CMD_FUNC0194
    Case 195
        GoSub *CMD_FUNC0195
    Case 196
        GoSub *CMD_FUNC0196
    Case 197
        GoSub *CMD_FUNC0197
    Case 198
        GoSub *CMD_FUNC0198
    Case 199
        GoSub *CMD_FUNC0199
    Case 200
        GoSub *CMD_FUNC0200
    Case 201
        GoSub *CMD_FUNC0201
    Case 202
        GoSub *CMD_FUNC0202
    Case 203
        GoSub *CMD_FUNC0203
    Case 204
        GoSub *CMD_FUNC0204
    Case 205
        GoSub *CMD_FUNC0205
    Case 206
        GoSub *CMD_FUNC0206
    Case 207
        GoSub *CMD_FUNC0207
    Case 208
        GoSub *CMD_FUNC0208
    Case 209
        GoSub *CMD_FUNC0209
    Case 210
        GoSub *CMD_FUNC0210
    Case 211
        GoSub *CMD_FUNC0211
    Case 212
        GoSub *CMD_FUNC0212
    Case 213
        GoSub *CMD_FUNC0213
    Case 214
        GoSub *CMD_FUNC0214
    Case 215
        GoSub *CMD_FUNC0215
    Case 216
        GoSub *CMD_FUNC0216
    Case 217
        GoSub *CMD_FUNC0217
    Case 218
        GoSub *CMD_FUNC0218
    Case 219
        GoSub *CMD_FUNC0219
    Case 220
        GoSub *CMD_FUNC0220
    Case 221
        GoSub *CMD_FUNC0221
    Case 222
        GoSub *CMD_FUNC0222
    Case 223
        GoSub *CMD_FUNC0223
    Case 224
        GoSub *CMD_FUNC0224
    Case 225
        GoSub *CMD_FUNC0225
    Case 226
        GoSub *CMD_FUNC0226
    Case 227
        GoSub *CMD_FUNC0227
    Case 228
        GoSub *CMD_FUNC0228
    Case 229
        GoSub *CMD_FUNC0229
    Case 230
        GoSub *CMD_FUNC0230
    Case 231
        GoSub *CMD_FUNC0231
    Case 232
        GoSub *CMD_FUNC0232
    Case 233
        GoSub *CMD_FUNC0233
    Case 234
        GoSub *CMD_FUNC0234
    Case 235
        GoSub *CMD_FUNC0235
    Case 236
        GoSub *CMD_FUNC0236
    Case 237
        GoSub *CMD_FUNC0237
    Case 238
        GoSub *CMD_FUNC0238
    Case 239
        GoSub *CMD_FUNC0239
    Case 240
        GoSub *CMD_FUNC0240
    Case 241
        GoSub *CMD_FUNC0241
    Case 242
        GoSub *CMD_FUNC0242
    Case 243
        GoSub *CMD_FUNC0243
    Case 244
        GoSub *CMD_FUNC0244
    Case 245
        GoSub *CMD_FUNC0245
    Case 246
        GoSub *CMD_FUNC0246
    Case 247
        GoSub *CMD_FUNC0247
    Case 248
        GoSub *CMD_FUNC0248
    Case 249
        GoSub *CMD_FUNC0249
    Case 250
        GoSub *CMD_FUNC0250
    Case 251
        GoSub *CMD_FUNC0251
    Case 252
        GoSub *CMD_FUNC0252
    Case 253
        GoSub *CMD_FUNC0253
    Case 254
        GoSub *CMD_FUNC0254
    Case 255
        GoSub *CMD_FUNC0255
    End Select

Catch
  Print "ErrorCommand = " + ERRCMND$
  Print "ErrorNo = " + Str$(Errno)
  ResponseCode& = -1
End Try
Return


'!Page

'********************************************
' Auto generated code
' Do not change the source code of this block. 
'********************************************

'!
'! Initialize Setting 
'!
*McrInit
    DIM CommandData&(4)
    DIM CommandResponse&(3)

    ArgmentCountMax& = 32
    CommandCountMax& = 256
    CommandDelimiter$ = " "
    CommandDelimiter1$ = Chr$(34)

    '! Alloc CommandName Table
    Dim CMD$(256)
    
    '! Set CommandNameTable_Start
    CMD$(0) = "RBEXT_MOVE_JOG_PLUS_X"
    CMD$(1) = "RBEXT_MOVE_JOG_MINUS_X"
    CMD$(2) = "RBEXT_MOVE_JOG_PLUS_Y"
    CMD$(3) = "RBEXT_MOVE_JOG_MINUS_Y"
    CMD$(4) = "RBEXT_MOVE_JOG_PLUS_Z"
    CMD$(5) = "RBEXT_MOVE_JOG_MINUS_Z"
    CMD$(6) = "RBEXT_MOVE_JOG_PLUS_RX"
    CMD$(7) = "RBEXT_MOVE_JOG_MINUS_RX"
    CMD$(8) = "RBEXT_MOVE_JOG_PLUS_RY"
    CMD$(9) = "RBEXT_MOVE_JOG_MINUS_RY"
    CMD$(10) = "RBEXT_MOVE_JOG_PLUS_RZ"
    CMD$(11) = "RBEXT_MOVE_JOG_MINUS_RZ"
    CMD$(12) = "RBEXT_MOVE_DST_POS"
    CMD$(13) = "RBEXT_MOVE_CAL_STR_POS"
    CMD$(14) = "RBEXT_MOVE_STD_GRP_POS"
    CMD$(15) = "RBEXT_MOVE_STD_IMG_POS"
    CMD$(16) = "RBEXT_MOVE_RES_CMD_POS"
    CMD$(17) = "RBEXT_EXEC_AUTO_CALIB_ALL"
    CMD$(18) = "RBEXT_EXEC_AUTO_CALIB_STEP"
    CMD$(19) = "RBEXT_SET_CAL_STR_POS"
    CMD$(20) = "RBEXT_SET_STD_GRP_POS"
    CMD$(21) = "RBEXT_SET_STD_IMG_POS"
    CMD$(22) = "RBEXT_SET_STD_WRK_POS"
    CMD$(23) = "RBEXT_GET_CUR_POS"
    CMD$(24) = "RBINT_INIT"
    CMD$(25) = "RBINT_FINAL"
    CMD$(26) = "RBINT_EXEC_COMMAND"
    CMD$(27) = "RBINT_CONV_ROT_COORD_TO_MAT"
    CMD$(28) = "RBINT_CONV_ROT_MAT_TO_COORD"
    CMD$(29) = "RBINT_TRANS_COORD"
    CMD$(30) = "RBINT_CALC_DST_POS"
    CMD$(31) = "RBINT_GET_VER_INF"
    CMD$(32) = "RBINT_GET_CUR_POS"
    CMD$(33) = "RBINT_MOVE_ROBOT"
    CMD$(34) = "RBINT_EXEC_AUTO_CALIB_STEP"
    CMD$(35) = "RBEXT_MOVE_STD_APPRO_POS"
    CMD$(36) = "RBEXT_MOVE_RES_APPRO_POS"
    CMD$(37) = "CMD0037"
    CMD$(38) = "CMD0038"
    CMD$(39) = "CMD0039"
    CMD$(40) = "CMD0040"
    CMD$(41) = "CMD0041"
    CMD$(42) = "CMD0042"
    CMD$(43) = "CMD0043"
    CMD$(44) = "CMD0044"
    CMD$(45) = "CMD0045"
    CMD$(46) = "CMD0046"
    CMD$(47) = "CMD0047"
    CMD$(48) = "CMD0048"
    CMD$(49) = "CMD0049"
    CMD$(50) = "CMD0050"
    CMD$(51) = "CMD0051"
    CMD$(52) = "CMD0052"
    CMD$(53) = "CMD0053"
    CMD$(54) = "CMD0054"
    CMD$(55) = "CMD0055"
    CMD$(56) = "CMD0056"
    CMD$(57) = "CMD0057"
    CMD$(58) = "CMD0058"
    CMD$(59) = "CMD0059"
    CMD$(60) = "CMD0060"
    CMD$(61) = "CMD0061"
    CMD$(62) = "CMD0062"
    CMD$(63) = "CMD0063"
    CMD$(64) = "CMD0064"
    CMD$(65) = "CMD0065"
    CMD$(66) = "CMD0066"
    CMD$(67) = "CMD0067"
    CMD$(68) = "CMD0068"
    CMD$(69) = "CMD0069"
    CMD$(70) = "CMD0070"
    CMD$(71) = "CMD0071"
    CMD$(72) = "CMD0072"
    CMD$(73) = "CMD0073"
    CMD$(74) = "CMD0074"
    CMD$(75) = "CMD0075"
    CMD$(76) = "CMD0076"
    CMD$(77) = "CMD0077"
    CMD$(78) = "CMD0078"
    CMD$(79) = "CMD0079"
    CMD$(80) = "CMD0080"
    CMD$(81) = "CMD0081"
    CMD$(82) = "CMD0082"
    CMD$(83) = "CMD0083"
    CMD$(84) = "CMD0084"
    CMD$(85) = "CMD0085"
    CMD$(86) = "CMD0086"
    CMD$(87) = "CMD0087"
    CMD$(88) = "CMD0088"
    CMD$(89) = "CMD0089"
    CMD$(90) = "CMD0090"
    CMD$(91) = "CMD0091"
    CMD$(92) = "CMD0092"
    CMD$(93) = "CMD0093"
    CMD$(94) = "CMD0094"
    CMD$(95) = "CMD0095"
    CMD$(96) = "CMD0096"
    CMD$(97) = "CMD0097"
    CMD$(98) = "CMD0098"
    CMD$(99) = "CMD0099"
    CMD$(100) = "CMD0100"
    CMD$(101) = "CMD0101"
    CMD$(102) = "CMD0102"
    CMD$(103) = "CMD0103"
    CMD$(104) = "CMD0104"
    CMD$(105) = "CMD0105"
    CMD$(106) = "CMD0106"
    CMD$(107) = "CMD0107"
    CMD$(108) = "CMD0108"
    CMD$(109) = "CMD0109"
    CMD$(110) = "CMD0110"
    CMD$(111) = "CMD0111"
    CMD$(112) = "CMD0112"
    CMD$(113) = "CMD0113"
    CMD$(114) = "CMD0114"
    CMD$(115) = "CMD0115"
    CMD$(116) = "CMD0116"
    CMD$(117) = "CMD0117"
    CMD$(118) = "CMD0118"
    CMD$(119) = "CMD0119"
    CMD$(120) = "CMD0120"
    CMD$(121) = "CMD0121"
    CMD$(122) = "CMD0122"
    CMD$(123) = "CMD0123"
    CMD$(124) = "CMD0124"
    CMD$(125) = "CMD0125"
    CMD$(126) = "CMD0126"
    CMD$(127) = "CMD0127"
    CMD$(128) = "CMD0128"
    CMD$(129) = "CMD0129"
    CMD$(130) = "CMD0130"
    CMD$(131) = "CMD0131"
    CMD$(132) = "CMD0132"
    CMD$(133) = "CMD0133"
    CMD$(134) = "CMD0134"
    CMD$(135) = "CMD0135"
    CMD$(136) = "CMD0136"
    CMD$(137) = "CMD0137"
    CMD$(138) = "CMD0138"
    CMD$(139) = "CMD0139"
    CMD$(140) = "CMD0140"
    CMD$(141) = "CMD0141"
    CMD$(142) = "CMD0142"
    CMD$(143) = "CMD0143"
    CMD$(144) = "CMD0144"
    CMD$(145) = "CMD0145"
    CMD$(146) = "CMD0146"
    CMD$(147) = "CMD0147"
    CMD$(148) = "CMD0148"
    CMD$(149) = "CMD0149"
    CMD$(150) = "CMD0150"
    CMD$(151) = "CMD0151"
    CMD$(152) = "CMD0152"
    CMD$(153) = "CMD0153"
    CMD$(154) = "CMD0154"
    CMD$(155) = "CMD0155"
    CMD$(156) = "CMD0156"
    CMD$(157) = "CMD0157"
    CMD$(158) = "CMD0158"
    CMD$(159) = "CMD0159"
    CMD$(160) = "CMD0160"
    CMD$(161) = "CMD0161"
    CMD$(162) = "CMD0162"
    CMD$(163) = "CMD0163"
    CMD$(164) = "CMD0164"
    CMD$(165) = "CMD0165"
    CMD$(166) = "CMD0166"
    CMD$(167) = "CMD0167"
    CMD$(168) = "CMD0168"
    CMD$(169) = "CMD0169"
    CMD$(170) = "CMD0170"
    CMD$(171) = "CMD0171"
    CMD$(172) = "CMD0172"
    CMD$(173) = "CMD0173"
    CMD$(174) = "CMD0174"
    CMD$(175) = "CMD0175"
    CMD$(176) = "CMD0176"
    CMD$(177) = "CMD0177"
    CMD$(178) = "CMD0178"
    CMD$(179) = "CMD0179"
    CMD$(180) = "CMD0180"
    CMD$(181) = "CMD0181"
    CMD$(182) = "CMD0182"
    CMD$(183) = "CMD0183"
    CMD$(184) = "CMD0184"
    CMD$(185) = "CMD0185"
    CMD$(186) = "CMD0186"
    CMD$(187) = "CMD0187"
    CMD$(188) = "CMD0188"
    CMD$(189) = "CMD0189"
    CMD$(190) = "CMD0190"
    CMD$(191) = "CMD0191"
    CMD$(192) = "CMD0192"
    CMD$(193) = "CMD0193"
    CMD$(194) = "CMD0194"
    CMD$(195) = "CMD0195"
    CMD$(196) = "CMD0196"
    CMD$(197) = "CMD0197"
    CMD$(198) = "CMD0198"
    CMD$(199) = "CMD0199"
    CMD$(200) = "CMD0200"
    CMD$(201) = "CMD0201"
    CMD$(202) = "CMD0202"
    CMD$(203) = "CMD0203"
    CMD$(204) = "CMD0204"
    CMD$(205) = "CMD0205"
    CMD$(206) = "CMD0206"
    CMD$(207) = "CMD0207"
    CMD$(208) = "CMD0208"
    CMD$(209) = "CMD0209"
    CMD$(210) = "CMD0210"
    CMD$(211) = "CMD0211"
    CMD$(212) = "CMD0212"
    CMD$(213) = "CMD0213"
    CMD$(214) = "CMD0214"
    CMD$(215) = "CMD0215"
    CMD$(216) = "CMD0216"
    CMD$(217) = "CMD0217"
    CMD$(218) = "CMD0218"
    CMD$(219) = "CMD0219"
    CMD$(220) = "CMD0220"
    CMD$(221) = "CMD0221"
    CMD$(222) = "CMD0222"
    CMD$(223) = "CMD0223"
    CMD$(224) = "CMD0224"
    CMD$(225) = "CMD0225"
    CMD$(226) = "CMD0226"
    CMD$(227) = "CMD0227"
    CMD$(228) = "CMD0228"
    CMD$(229) = "CMD0229"
    CMD$(230) = "CMD0230"
    CMD$(231) = "CMD0231"
    CMD$(232) = "CMD0232"
    CMD$(233) = "CMD0233"
    CMD$(234) = "CMD0234"
    CMD$(235) = "CMD0235"
    CMD$(236) = "CMD0236"
    CMD$(237) = "CMD0237"
    CMD$(238) = "CMD0238"
    CMD$(239) = "CMD0239"
    CMD$(240) = "CMD0240"
    CMD$(241) = "CMD0241"
    CMD$(242) = "CMD0242"
    CMD$(243) = "CMD0243"
    CMD$(244) = "CMD0244"
    CMD$(245) = "CMD0245"
    CMD$(246) = "CMD0246"
    CMD$(247) = "CMD0247"
    CMD$(248) = "CMD0248"
    CMD$(249) = "CMD0249"
    CMD$(250) = "CMD0250"
    CMD$(251) = "CMD0251"
    CMD$(252) = "CMD0252"
    CMD$(253) = "CMD0253"
    CMD$(254) = "CMD0254"
    CMD$(255) = "CMD0255"
    '! Set CommandNameTable_End
    
    '! Alloc MeasureStoptable
    Dim MeasureStopTable&(256)
    
    '! Set MeasureStopFlag_Start
    MeasureStopTable&(0) = False
    MeasureStopTable&(1) = False
    MeasureStopTable&(2) = False
    MeasureStopTable&(3) = False
    MeasureStopTable&(4) = False
    MeasureStopTable&(5) = False
    MeasureStopTable&(6) = False
    MeasureStopTable&(7) = False
    MeasureStopTable&(8) = False
    MeasureStopTable&(9) = False
    MeasureStopTable&(10) = False
    MeasureStopTable&(11) = False
    MeasureStopTable&(12) = False
    MeasureStopTable&(13) = False
    MeasureStopTable&(14) = False
    MeasureStopTable&(15) = False
    MeasureStopTable&(16) = False
    MeasureStopTable&(17) = False
    MeasureStopTable&(18) = False
    MeasureStopTable&(19) = False
    MeasureStopTable&(20) = False
    MeasureStopTable&(21) = False
    MeasureStopTable&(22) = False
    MeasureStopTable&(23) = False
    MeasureStopTable&(24) = False
    MeasureStopTable&(25) = False
    MeasureStopTable&(26) = False
    MeasureStopTable&(27) = False
    MeasureStopTable&(28) = False
    MeasureStopTable&(29) = False
    MeasureStopTable&(30) = False
    MeasureStopTable&(31) = False
    MeasureStopTable&(32) = False
    MeasureStopTable&(33) = False
    MeasureStopTable&(34) = False
    MeasureStopTable&(35) = False
    MeasureStopTable&(36) = False
    MeasureStopTable&(37) = True
    MeasureStopTable&(38) = True
    MeasureStopTable&(39) = True
    MeasureStopTable&(40) = True
    MeasureStopTable&(41) = True
    MeasureStopTable&(42) = True
    MeasureStopTable&(43) = True
    MeasureStopTable&(44) = True
    MeasureStopTable&(45) = True
    MeasureStopTable&(46) = True
    MeasureStopTable&(47) = True
    MeasureStopTable&(48) = True
    MeasureStopTable&(49) = True
    MeasureStopTable&(50) = True
    MeasureStopTable&(51) = True
    MeasureStopTable&(52) = True
    MeasureStopTable&(53) = True
    MeasureStopTable&(54) = True
    MeasureStopTable&(55) = True
    MeasureStopTable&(56) = True
    MeasureStopTable&(57) = True
    MeasureStopTable&(58) = True
    MeasureStopTable&(59) = True
    MeasureStopTable&(60) = True
    MeasureStopTable&(61) = True
    MeasureStopTable&(62) = True
    MeasureStopTable&(63) = True
    MeasureStopTable&(64) = True
    MeasureStopTable&(65) = True
    MeasureStopTable&(66) = True
    MeasureStopTable&(67) = True
    MeasureStopTable&(68) = True
    MeasureStopTable&(69) = True
    MeasureStopTable&(70) = True
    MeasureStopTable&(71) = True
    MeasureStopTable&(72) = True
    MeasureStopTable&(73) = True
    MeasureStopTable&(74) = True
    MeasureStopTable&(75) = True
    MeasureStopTable&(76) = True
    MeasureStopTable&(77) = True
    MeasureStopTable&(78) = True
    MeasureStopTable&(79) = True
    MeasureStopTable&(80) = True
    MeasureStopTable&(81) = True
    MeasureStopTable&(82) = True
    MeasureStopTable&(83) = True
    MeasureStopTable&(84) = True
    MeasureStopTable&(85) = True
    MeasureStopTable&(86) = True
    MeasureStopTable&(87) = True
    MeasureStopTable&(88) = True
    MeasureStopTable&(89) = True
    MeasureStopTable&(90) = True
    MeasureStopTable&(91) = True
    MeasureStopTable&(92) = True
    MeasureStopTable&(93) = True
    MeasureStopTable&(94) = True
    MeasureStopTable&(95) = True
    MeasureStopTable&(96) = True
    MeasureStopTable&(97) = True
    MeasureStopTable&(98) = True
    MeasureStopTable&(99) = True
    MeasureStopTable&(100) = True
    MeasureStopTable&(101) = True
    MeasureStopTable&(102) = True
    MeasureStopTable&(103) = True
    MeasureStopTable&(104) = True
    MeasureStopTable&(105) = True
    MeasureStopTable&(106) = True
    MeasureStopTable&(107) = True
    MeasureStopTable&(108) = True
    MeasureStopTable&(109) = True
    MeasureStopTable&(110) = True
    MeasureStopTable&(111) = True
    MeasureStopTable&(112) = True
    MeasureStopTable&(113) = True
    MeasureStopTable&(114) = True
    MeasureStopTable&(115) = True
    MeasureStopTable&(116) = True
    MeasureStopTable&(117) = True
    MeasureStopTable&(118) = True
    MeasureStopTable&(119) = True
    MeasureStopTable&(120) = True
    MeasureStopTable&(121) = True
    MeasureStopTable&(122) = True
    MeasureStopTable&(123) = True
    MeasureStopTable&(124) = True
    MeasureStopTable&(125) = True
    MeasureStopTable&(126) = True
    MeasureStopTable&(127) = True
    MeasureStopTable&(128) = True
    MeasureStopTable&(129) = True
    MeasureStopTable&(130) = True
    MeasureStopTable&(131) = True
    MeasureStopTable&(132) = True
    MeasureStopTable&(133) = True
    MeasureStopTable&(134) = True
    MeasureStopTable&(135) = True
    MeasureStopTable&(136) = True
    MeasureStopTable&(137) = True
    MeasureStopTable&(138) = True
    MeasureStopTable&(139) = True
    MeasureStopTable&(140) = True
    MeasureStopTable&(141) = True
    MeasureStopTable&(142) = True
    MeasureStopTable&(143) = True
    MeasureStopTable&(144) = True
    MeasureStopTable&(145) = True
    MeasureStopTable&(146) = True
    MeasureStopTable&(147) = True
    MeasureStopTable&(148) = True
    MeasureStopTable&(149) = True
    MeasureStopTable&(150) = True
    MeasureStopTable&(151) = True
    MeasureStopTable&(152) = True
    MeasureStopTable&(153) = True
    MeasureStopTable&(154) = True
    MeasureStopTable&(155) = True
    MeasureStopTable&(156) = True
    MeasureStopTable&(157) = True
    MeasureStopTable&(158) = True
    MeasureStopTable&(159) = True
    MeasureStopTable&(160) = True
    MeasureStopTable&(161) = True
    MeasureStopTable&(162) = True
    MeasureStopTable&(163) = True
    MeasureStopTable&(164) = True
    MeasureStopTable&(165) = True
    MeasureStopTable&(166) = True
    MeasureStopTable&(167) = True
    MeasureStopTable&(168) = True
    MeasureStopTable&(169) = True
    MeasureStopTable&(170) = True
    MeasureStopTable&(171) = True
    MeasureStopTable&(172) = True
    MeasureStopTable&(173) = True
    MeasureStopTable&(174) = True
    MeasureStopTable&(175) = True
    MeasureStopTable&(176) = True
    MeasureStopTable&(177) = True
    MeasureStopTable&(178) = True
    MeasureStopTable&(179) = True
    MeasureStopTable&(180) = True
    MeasureStopTable&(181) = True
    MeasureStopTable&(182) = True
    MeasureStopTable&(183) = True
    MeasureStopTable&(184) = True
    MeasureStopTable&(185) = True
    MeasureStopTable&(186) = True
    MeasureStopTable&(187) = True
    MeasureStopTable&(188) = True
    MeasureStopTable&(189) = True
    MeasureStopTable&(190) = True
    MeasureStopTable&(191) = True
    MeasureStopTable&(192) = True
    MeasureStopTable&(193) = True
    MeasureStopTable&(194) = True
    MeasureStopTable&(195) = True
    MeasureStopTable&(196) = True
    MeasureStopTable&(197) = True
    MeasureStopTable&(198) = True
    MeasureStopTable&(199) = True
    MeasureStopTable&(200) = True
    MeasureStopTable&(201) = True
    MeasureStopTable&(202) = True
    MeasureStopTable&(203) = True
    MeasureStopTable&(204) = True
    MeasureStopTable&(205) = True
    MeasureStopTable&(206) = True
    MeasureStopTable&(207) = True
    MeasureStopTable&(208) = True
    MeasureStopTable&(209) = True
    MeasureStopTable&(210) = True
    MeasureStopTable&(211) = True
    MeasureStopTable&(212) = True
    MeasureStopTable&(213) = True
    MeasureStopTable&(214) = True
    MeasureStopTable&(215) = True
    MeasureStopTable&(216) = True
    MeasureStopTable&(217) = True
    MeasureStopTable&(218) = True
    MeasureStopTable&(219) = True
    MeasureStopTable&(220) = True
    MeasureStopTable&(221) = True
    MeasureStopTable&(222) = True
    MeasureStopTable&(223) = True
    MeasureStopTable&(224) = True
    MeasureStopTable&(225) = True
    MeasureStopTable&(226) = True
    MeasureStopTable&(227) = True
    MeasureStopTable&(228) = True
    MeasureStopTable&(229) = True
    MeasureStopTable&(230) = True
    MeasureStopTable&(231) = True
    MeasureStopTable&(232) = True
    MeasureStopTable&(233) = True
    MeasureStopTable&(234) = True
    MeasureStopTable&(235) = True
    MeasureStopTable&(236) = True
    MeasureStopTable&(237) = True
    MeasureStopTable&(238) = True
    MeasureStopTable&(239) = True
    MeasureStopTable&(240) = True
    MeasureStopTable&(241) = True
    MeasureStopTable&(242) = True
    MeasureStopTable&(243) = True
    MeasureStopTable&(244) = True
    MeasureStopTable&(245) = True
    MeasureStopTable&(246) = True
    MeasureStopTable&(247) = True
    MeasureStopTable&(248) = True
    MeasureStopTable&(249) = True
    MeasureStopTable&(250) = True
    MeasureStopTable&(251) = True
    MeasureStopTable&(252) = True
    MeasureStopTable&(253) = True
    MeasureStopTable&(254) = True
    MeasureStopTable&(255) = True
    '! Set MeasureStopFlag_End


    '! Alloc Activetable
    Dim ActiveTable&(256)
    '! Set ActiveFlag_Start
    ActiveTable&(0) = False
    ActiveTable&(1) = False
    ActiveTable&(2) = False
    ActiveTable&(3) = False
    ActiveTable&(4) = False
    ActiveTable&(5) = False
    ActiveTable&(6) = False
    ActiveTable&(7) = False
    ActiveTable&(8) = False
    ActiveTable&(9) = False
    ActiveTable&(10) = False
    ActiveTable&(11) = False
    ActiveTable&(12) = False
    ActiveTable&(13) = False
    ActiveTable&(14) = False
    ActiveTable&(15) = False
    ActiveTable&(16) = False
    ActiveTable&(17) = False
    ActiveTable&(18) = False
    ActiveTable&(19) = False
    ActiveTable&(20) = False
    ActiveTable&(21) = False
    ActiveTable&(22) = False
    ActiveTable&(23) = False
    ActiveTable&(24) = False
    ActiveTable&(25) = False
    ActiveTable&(26) = False
    ActiveTable&(27) = False
    ActiveTable&(28) = False
    ActiveTable&(29) = False
    ActiveTable&(30) = False
    ActiveTable&(31) = False
    ActiveTable&(32) = False
    ActiveTable&(33) = False
    ActiveTable&(34) = False
    ActiveTable&(35) = False
    ActiveTable&(36) = False
    ActiveTable&(37) = False
    ActiveTable&(38) = False
    ActiveTable&(39) = False
    ActiveTable&(40) = False
    ActiveTable&(41) = False
    ActiveTable&(42) = False
    ActiveTable&(43) = False
    ActiveTable&(44) = False
    ActiveTable&(45) = False
    ActiveTable&(46) = False
    ActiveTable&(47) = False
    ActiveTable&(48) = False
    ActiveTable&(49) = False
    ActiveTable&(50) = False
    ActiveTable&(51) = False
    ActiveTable&(52) = False
    ActiveTable&(53) = False
    ActiveTable&(54) = False
    ActiveTable&(55) = False
    ActiveTable&(56) = False
    ActiveTable&(57) = False
    ActiveTable&(58) = False
    ActiveTable&(59) = False
    ActiveTable&(60) = False
    ActiveTable&(61) = False
    ActiveTable&(62) = False
    ActiveTable&(63) = False
    ActiveTable&(64) = False
    ActiveTable&(65) = False
    ActiveTable&(66) = False
    ActiveTable&(67) = False
    ActiveTable&(68) = False
    ActiveTable&(69) = False
    ActiveTable&(70) = False
    ActiveTable&(71) = False
    ActiveTable&(72) = False
    ActiveTable&(73) = False
    ActiveTable&(74) = False
    ActiveTable&(75) = False
    ActiveTable&(76) = False
    ActiveTable&(77) = False
    ActiveTable&(78) = False
    ActiveTable&(79) = False
    ActiveTable&(80) = False
    ActiveTable&(81) = False
    ActiveTable&(82) = False
    ActiveTable&(83) = False
    ActiveTable&(84) = False
    ActiveTable&(85) = False
    ActiveTable&(86) = False
    ActiveTable&(87) = False
    ActiveTable&(88) = False
    ActiveTable&(89) = False
    ActiveTable&(90) = False
    ActiveTable&(91) = False
    ActiveTable&(92) = False
    ActiveTable&(93) = False
    ActiveTable&(94) = False
    ActiveTable&(95) = False
    ActiveTable&(96) = False
    ActiveTable&(97) = False
    ActiveTable&(98) = False
    ActiveTable&(99) = False
    ActiveTable&(100) = False
    ActiveTable&(101) = False
    ActiveTable&(102) = False
    ActiveTable&(103) = False
    ActiveTable&(104) = False
    ActiveTable&(105) = False
    ActiveTable&(106) = False
    ActiveTable&(107) = False
    ActiveTable&(108) = False
    ActiveTable&(109) = False
    ActiveTable&(110) = False
    ActiveTable&(111) = False
    ActiveTable&(112) = False
    ActiveTable&(113) = False
    ActiveTable&(114) = False
    ActiveTable&(115) = False
    ActiveTable&(116) = False
    ActiveTable&(117) = False
    ActiveTable&(118) = False
    ActiveTable&(119) = False
    ActiveTable&(120) = False
    ActiveTable&(121) = False
    ActiveTable&(122) = False
    ActiveTable&(123) = False
    ActiveTable&(124) = False
    ActiveTable&(125) = False
    ActiveTable&(126) = False
    ActiveTable&(127) = False
    ActiveTable&(128) = False
    ActiveTable&(129) = False
    ActiveTable&(130) = False
    ActiveTable&(131) = False
    ActiveTable&(132) = False
    ActiveTable&(133) = False
    ActiveTable&(134) = False
    ActiveTable&(135) = False
    ActiveTable&(136) = False
    ActiveTable&(137) = False
    ActiveTable&(138) = False
    ActiveTable&(139) = False
    ActiveTable&(140) = False
    ActiveTable&(141) = False
    ActiveTable&(142) = False
    ActiveTable&(143) = False
    ActiveTable&(144) = False
    ActiveTable&(145) = False
    ActiveTable&(146) = False
    ActiveTable&(147) = False
    ActiveTable&(148) = False
    ActiveTable&(149) = False
    ActiveTable&(150) = False
    ActiveTable&(151) = False
    ActiveTable&(152) = False
    ActiveTable&(153) = False
    ActiveTable&(154) = False
    ActiveTable&(155) = False
    ActiveTable&(156) = False
    ActiveTable&(157) = False
    ActiveTable&(158) = False
    ActiveTable&(159) = False
    ActiveTable&(160) = False
    ActiveTable&(161) = False
    ActiveTable&(162) = False
    ActiveTable&(163) = False
    ActiveTable&(164) = False
    ActiveTable&(165) = False
    ActiveTable&(166) = False
    ActiveTable&(167) = False
    ActiveTable&(168) = False
    ActiveTable&(169) = False
    ActiveTable&(170) = False
    ActiveTable&(171) = False
    ActiveTable&(172) = False
    ActiveTable&(173) = False
    ActiveTable&(174) = False
    ActiveTable&(175) = False
    ActiveTable&(176) = False
    ActiveTable&(177) = False
    ActiveTable&(178) = False
    ActiveTable&(179) = False
    ActiveTable&(180) = False
    ActiveTable&(181) = False
    ActiveTable&(182) = False
    ActiveTable&(183) = False
    ActiveTable&(184) = False
    ActiveTable&(185) = False
    ActiveTable&(186) = False
    ActiveTable&(187) = False
    ActiveTable&(188) = False
    ActiveTable&(189) = False
    ActiveTable&(190) = False
    ActiveTable&(191) = False
    ActiveTable&(192) = False
    ActiveTable&(193) = False
    ActiveTable&(194) = False
    ActiveTable&(195) = False
    ActiveTable&(196) = False
    ActiveTable&(197) = False
    ActiveTable&(198) = False
    ActiveTable&(199) = False
    ActiveTable&(200) = False
    ActiveTable&(201) = False
    ActiveTable&(202) = False
    ActiveTable&(203) = False
    ActiveTable&(204) = False
    ActiveTable&(205) = False
    ActiveTable&(206) = False
    ActiveTable&(207) = False
    ActiveTable&(208) = False
    ActiveTable&(209) = False
    ActiveTable&(210) = False
    ActiveTable&(211) = False
    ActiveTable&(212) = False
    ActiveTable&(213) = False
    ActiveTable&(214) = False
    ActiveTable&(215) = False
    ActiveTable&(216) = False
    ActiveTable&(217) = False
    ActiveTable&(218) = False
    ActiveTable&(219) = False
    ActiveTable&(220) = False
    ActiveTable&(221) = False
    ActiveTable&(222) = False
    ActiveTable&(223) = False
    ActiveTable&(224) = False
    ActiveTable&(225) = False
    ActiveTable&(226) = False
    ActiveTable&(227) = False
    ActiveTable&(228) = False
    ActiveTable&(229) = False
    ActiveTable&(230) = False
    ActiveTable&(231) = False
    ActiveTable&(232) = False
    ActiveTable&(233) = False
    ActiveTable&(234) = False
    ActiveTable&(235) = False
    ActiveTable&(236) = False
    ActiveTable&(237) = False
    ActiveTable&(238) = False
    ActiveTable&(239) = False
    ActiveTable&(240) = False
    ActiveTable&(241) = False
    ActiveTable&(242) = False
    ActiveTable&(243) = False
    ActiveTable&(244) = False
    ActiveTable&(245) = False
    ActiveTable&(246) = False
    ActiveTable&(247) = False
    ActiveTable&(248) = False
    ActiveTable&(249) = False
    ActiveTable&(250) = False
    ActiveTable&(251) = False
    ActiveTable&(252) = False
    ActiveTable&(253) = False
    ActiveTable&(254) = False
    ActiveTable&(255) = False
    '! Set ActiveFlag_End
        
Return

*GetDelimiter1Count
    For count& = 1 To Len(ArgmentsLine$)
       If Mid$(ArgmentsLine$, count&, 1) = CommandDelimiter1$ Then
           Delimiter1Count& = Delimiter1Count& + 1
        EndIf
    Next    
Return

*GetDelimiterCount
    For count& = 1 To Len(SubArgmentsLine$)
       If Mid$(SubArgmentsLine$, count&, 1) = CommandDelimiter$ Then
           DelimiterCount& = DelimiterCount& + 1
        EndIf
    Next    
Return

*SetArgument
  If ArgmentsLength& <= 31 Then 
    ArgumentString$(ArgmentsLength&) = ArgmentString$(ArgmentsLength&)
    Try
        ArgmentValue#(ArgmentsLength&) = Val(ArgmentString$(ArgmentsLength&))
    Catch
        ArgmentValue#(ArgmentsLength&) = 0
    End Try
    ArgumentValue#(ArgmentsLength&) = ArgmentValue#(ArgmentsLength&)
    ArgmentsLength& = ArgmentsLength& + 1
    ArgumentsLength& = ArgmentsLength&
  EndIf
Return

'! Function name table_Start
*CMD_FUNC0000
    Gosub *RBEXT_MOVE_JOG_PLUS_X
Return
*CMD_FUNC0001
    Gosub *RBEXT_MOVE_JOG_MINUS_X
Return
*CMD_FUNC0002
    Gosub *RBEXT_MOVE_JOG_PLUS_Y
Return
*CMD_FUNC0003
    Gosub *RBEXT_MOVE_JOG_MINUS_Y
Return
*CMD_FUNC0004
    Gosub *RBEXT_MOVE_JOG_PLUS_Z
Return
*CMD_FUNC0005
    Gosub *RBEXT_MOVE_JOG_MINUS_Z
Return
*CMD_FUNC0006
    Gosub *RBEXT_MOVE_JOG_PLUS_RX
Return
*CMD_FUNC0007
    Gosub *RBEXT_MOVE_JOG_MINUS_RX
Return
*CMD_FUNC0008
    Gosub *RBEXT_MOVE_JOG_PLUS_RY
Return
*CMD_FUNC0009
    Gosub *RBEXT_MOVE_JOG_MINUS_RY
Return
*CMD_FUNC0010
    Gosub *RBEXT_MOVE_JOG_PLUS_RZ
Return
*CMD_FUNC0011
    Gosub *RBEXT_MOVE_JOG_MINUS_RZ
Return
*CMD_FUNC0012
    Gosub *RBEXT_MOVE_DST_POS
Return
*CMD_FUNC0013
    Gosub *RBEXT_MOVE_CAL_STR_POS
Return
*CMD_FUNC0014
    Gosub *RBEXT_MOVE_STD_GRP_POS
Return
*CMD_FUNC0015
    Gosub *RBEXT_MOVE_STD_IMG_POS
Return
*CMD_FUNC0016
    Gosub *RBEXT_MOVE_RES_CMD_POS
Return
*CMD_FUNC0017
    Gosub *RBEXT_EXEC_AUTO_CALIB_ALL
Return
*CMD_FUNC0018
    Gosub *RBEXT_EXEC_AUTO_CALIB_STEP
Return
*CMD_FUNC0019
    Gosub *RBEXT_SET_CAL_STR_POS
Return
*CMD_FUNC0020
    Gosub *RBEXT_SET_STD_GRP_POS
Return
*CMD_FUNC0021
    Gosub *RBEXT_SET_STD_IMG_POS
Return
*CMD_FUNC0022
    Gosub *RBEXT_SET_STD_WRK_POS
Return
*CMD_FUNC0023
    Gosub *RBEXT_GET_CUR_POS
Return
*CMD_FUNC0024
    Gosub *RBINT_INIT
Return
*CMD_FUNC0025
    Gosub *RBINT_FINAL
Return
*CMD_FUNC0026
    Gosub *RBINT_EXEC_COMMAND
Return
*CMD_FUNC0027
    Gosub *RBINT_CONV_ROT_COORD_TO_MAT
Return
*CMD_FUNC0028
    Gosub *RBINT_CONV_ROT_MAT_TO_COORD
Return
*CMD_FUNC0029
    Gosub *RBINT_TRANS_COORD
Return
*CMD_FUNC0030
    Gosub *RBINT_CALC_DST_POS
Return
*CMD_FUNC0031
    Gosub *RBINT_GET_VER_INF
Return
*CMD_FUNC0032
    Gosub *RBINT_GET_CUR_POS
Return
*CMD_FUNC0033
    Gosub *RBINT_MOVE_ROBOT
Return
*CMD_FUNC0034
    Gosub *RBINT_EXEC_AUTO_CALIB_STEP
Return
*CMD_FUNC0035
    Gosub *RBEXT_MOVE_STD_APPRO_POS
Return
*CMD_FUNC0036
    Gosub *RBEXT_MOVE_RES_APPRO_POS
Return
*CMD_FUNC0037
    Gosub *FUNC_0037
Return
*CMD_FUNC0038
    Gosub *FUNC_0038
Return
*CMD_FUNC0039
    Gosub *FUNC_0039
Return
*CMD_FUNC0040
    Gosub *FUNC_0040
Return
*CMD_FUNC0041
    Gosub *FUNC_0041
Return
*CMD_FUNC0042
    Gosub *FUNC_0042
Return
*CMD_FUNC0043
    Gosub *FUNC_0043
Return
*CMD_FUNC0044
    Gosub *FUNC_0044
Return
*CMD_FUNC0045
    Gosub *FUNC_0045
Return
*CMD_FUNC0046
    Gosub *FUNC_0046
Return
*CMD_FUNC0047
    Gosub *FUNC_0047
Return
*CMD_FUNC0048
    Gosub *FUNC_0048
Return
*CMD_FUNC0049
    Gosub *FUNC_0049
Return
*CMD_FUNC0050
    Gosub *FUNC_0050
Return
*CMD_FUNC0051
    Gosub *FUNC_0051
Return
*CMD_FUNC0052
    Gosub *FUNC_0052
Return
*CMD_FUNC0053
    Gosub *FUNC_0053
Return
*CMD_FUNC0054
    Gosub *FUNC_0054
Return
*CMD_FUNC0055
    Gosub *FUNC_0055
Return
*CMD_FUNC0056
    Gosub *FUNC_0056
Return
*CMD_FUNC0057
    Gosub *FUNC_0057
Return
*CMD_FUNC0058
    Gosub *FUNC_0058
Return
*CMD_FUNC0059
    Gosub *FUNC_0059
Return
*CMD_FUNC0060
    Gosub *FUNC_0060
Return
*CMD_FUNC0061
    Gosub *FUNC_0061
Return
*CMD_FUNC0062
    Gosub *FUNC_0062
Return
*CMD_FUNC0063
    Gosub *FUNC_0063
Return
*CMD_FUNC0064
    Gosub *FUNC_0064
Return
*CMD_FUNC0065
    Gosub *FUNC_0065
Return
*CMD_FUNC0066
    Gosub *FUNC_0066
Return
*CMD_FUNC0067
    Gosub *FUNC_0067
Return
*CMD_FUNC0068
    Gosub *FUNC_0068
Return
*CMD_FUNC0069
    Gosub *FUNC_0069
Return
*CMD_FUNC0070
    Gosub *FUNC_0070
Return
*CMD_FUNC0071
    Gosub *FUNC_0071
Return
*CMD_FUNC0072
    Gosub *FUNC_0072
Return
*CMD_FUNC0073
    Gosub *FUNC_0073
Return
*CMD_FUNC0074
    Gosub *FUNC_0074
Return
*CMD_FUNC0075
    Gosub *FUNC_0075
Return
*CMD_FUNC0076
    Gosub *FUNC_0076
Return
*CMD_FUNC0077
    Gosub *FUNC_0077
Return
*CMD_FUNC0078
    Gosub *FUNC_0078
Return
*CMD_FUNC0079
    Gosub *FUNC_0079
Return
*CMD_FUNC0080
    Gosub *FUNC_0080
Return
*CMD_FUNC0081
    Gosub *FUNC_0081
Return
*CMD_FUNC0082
    Gosub *FUNC_0082
Return
*CMD_FUNC0083
    Gosub *FUNC_0083
Return
*CMD_FUNC0084
    Gosub *FUNC_0084
Return
*CMD_FUNC0085
    Gosub *FUNC_0085
Return
*CMD_FUNC0086
    Gosub *FUNC_0086
Return
*CMD_FUNC0087
    Gosub *FUNC_0087
Return
*CMD_FUNC0088
    Gosub *FUNC_0088
Return
*CMD_FUNC0089
    Gosub *FUNC_0089
Return
*CMD_FUNC0090
    Gosub *FUNC_0090
Return
*CMD_FUNC0091
    Gosub *FUNC_0091
Return
*CMD_FUNC0092
    Gosub *FUNC_0092
Return
*CMD_FUNC0093
    Gosub *FUNC_0093
Return
*CMD_FUNC0094
    Gosub *FUNC_0094
Return
*CMD_FUNC0095
    Gosub *FUNC_0095
Return
*CMD_FUNC0096
    Gosub *FUNC_0096
Return
*CMD_FUNC0097
    Gosub *FUNC_0097
Return
*CMD_FUNC0098
    Gosub *FUNC_0098
Return
*CMD_FUNC0099
    Gosub *FUNC_0099
Return
*CMD_FUNC0100
    Gosub *FUNC_0100
Return
*CMD_FUNC0101
    Gosub *FUNC_0101
Return
*CMD_FUNC0102
    Gosub *FUNC_0102
Return
*CMD_FUNC0103
    Gosub *FUNC_0103
Return
*CMD_FUNC0104
    Gosub *FUNC_0104
Return
*CMD_FUNC0105
    Gosub *FUNC_0105
Return
*CMD_FUNC0106
    Gosub *FUNC_0106
Return
*CMD_FUNC0107
    Gosub *FUNC_0107
Return
*CMD_FUNC0108
    Gosub *FUNC_0108
Return
*CMD_FUNC0109
    Gosub *FUNC_0109
Return
*CMD_FUNC0110
    Gosub *FUNC_0110
Return
*CMD_FUNC0111
    Gosub *FUNC_0111
Return
*CMD_FUNC0112
    Gosub *FUNC_0112
Return
*CMD_FUNC0113
    Gosub *FUNC_0113
Return
*CMD_FUNC0114
    Gosub *FUNC_0114
Return
*CMD_FUNC0115
    Gosub *FUNC_0115
Return
*CMD_FUNC0116
    Gosub *FUNC_0116
Return
*CMD_FUNC0117
    Gosub *FUNC_0117
Return
*CMD_FUNC0118
    Gosub *FUNC_0118
Return
*CMD_FUNC0119
    Gosub *FUNC_0119
Return
*CMD_FUNC0120
    Gosub *FUNC_0120
Return
*CMD_FUNC0121
    Gosub *FUNC_0121
Return
*CMD_FUNC0122
    Gosub *FUNC_0122
Return
*CMD_FUNC0123
    Gosub *FUNC_0123
Return
*CMD_FUNC0124
    Gosub *FUNC_0124
Return
*CMD_FUNC0125
    Gosub *FUNC_0125
Return
*CMD_FUNC0126
    Gosub *FUNC_0126
Return
*CMD_FUNC0127
    Gosub *FUNC_0127
Return
*CMD_FUNC0128
    Gosub *FUNC_0128
Return
*CMD_FUNC0129
    Gosub *FUNC_0129
Return
*CMD_FUNC0130
    Gosub *FUNC_0130
Return
*CMD_FUNC0131
    Gosub *FUNC_0131
Return
*CMD_FUNC0132
    Gosub *FUNC_0132
Return
*CMD_FUNC0133
    Gosub *FUNC_0133
Return
*CMD_FUNC0134
    Gosub *FUNC_0134
Return
*CMD_FUNC0135
    Gosub *FUNC_0135
Return
*CMD_FUNC0136
    Gosub *FUNC_0136
Return
*CMD_FUNC0137
    Gosub *FUNC_0137
Return
*CMD_FUNC0138
    Gosub *FUNC_0138
Return
*CMD_FUNC0139
    Gosub *FUNC_0139
Return
*CMD_FUNC0140
    Gosub *FUNC_0140
Return
*CMD_FUNC0141
    Gosub *FUNC_0141
Return
*CMD_FUNC0142
    Gosub *FUNC_0142
Return
*CMD_FUNC0143
    Gosub *FUNC_0143
Return
*CMD_FUNC0144
    Gosub *FUNC_0144
Return
*CMD_FUNC0145
    Gosub *FUNC_0145
Return
*CMD_FUNC0146
    Gosub *FUNC_0146
Return
*CMD_FUNC0147
    Gosub *FUNC_0147
Return
*CMD_FUNC0148
    Gosub *FUNC_0148
Return
*CMD_FUNC0149
    Gosub *FUNC_0149
Return
*CMD_FUNC0150
    Gosub *FUNC_0150
Return
*CMD_FUNC0151
    Gosub *FUNC_0151
Return
*CMD_FUNC0152
    Gosub *FUNC_0152
Return
*CMD_FUNC0153
    Gosub *FUNC_0153
Return
*CMD_FUNC0154
    Gosub *FUNC_0154
Return
*CMD_FUNC0155
    Gosub *FUNC_0155
Return
*CMD_FUNC0156
    Gosub *FUNC_0156
Return
*CMD_FUNC0157
    Gosub *FUNC_0157
Return
*CMD_FUNC0158
    Gosub *FUNC_0158
Return
*CMD_FUNC0159
    Gosub *FUNC_0159
Return
*CMD_FUNC0160
    Gosub *FUNC_0160
Return
*CMD_FUNC0161
    Gosub *FUNC_0161
Return
*CMD_FUNC0162
    Gosub *FUNC_0162
Return
*CMD_FUNC0163
    Gosub *FUNC_0163
Return
*CMD_FUNC0164
    Gosub *FUNC_0164
Return
*CMD_FUNC0165
    Gosub *FUNC_0165
Return
*CMD_FUNC0166
    Gosub *FUNC_0166
Return
*CMD_FUNC0167
    Gosub *FUNC_0167
Return
*CMD_FUNC0168
    Gosub *FUNC_0168
Return
*CMD_FUNC0169
    Gosub *FUNC_0169
Return
*CMD_FUNC0170
    Gosub *FUNC_0170
Return
*CMD_FUNC0171
    Gosub *FUNC_0171
Return
*CMD_FUNC0172
    Gosub *FUNC_0172
Return
*CMD_FUNC0173
    Gosub *FUNC_0173
Return
*CMD_FUNC0174
    Gosub *FUNC_0174
Return
*CMD_FUNC0175
    Gosub *FUNC_0175
Return
*CMD_FUNC0176
    Gosub *FUNC_0176
Return
*CMD_FUNC0177
    Gosub *FUNC_0177
Return
*CMD_FUNC0178
    Gosub *FUNC_0178
Return
*CMD_FUNC0179
    Gosub *FUNC_0179
Return
*CMD_FUNC0180
    Gosub *FUNC_0180
Return
*CMD_FUNC0181
    Gosub *FUNC_0181
Return
*CMD_FUNC0182
    Gosub *FUNC_0182
Return
*CMD_FUNC0183
    Gosub *FUNC_0183
Return
*CMD_FUNC0184
    Gosub *FUNC_0184
Return
*CMD_FUNC0185
    Gosub *FUNC_0185
Return
*CMD_FUNC0186
    Gosub *FUNC_0186
Return
*CMD_FUNC0187
    Gosub *FUNC_0187
Return
*CMD_FUNC0188
    Gosub *FUNC_0188
Return
*CMD_FUNC0189
    Gosub *FUNC_0189
Return
*CMD_FUNC0190
    Gosub *FUNC_0190
Return
*CMD_FUNC0191
    Gosub *FUNC_0191
Return
*CMD_FUNC0192
    Gosub *FUNC_0192
Return
*CMD_FUNC0193
    Gosub *FUNC_0193
Return
*CMD_FUNC0194
    Gosub *FUNC_0194
Return
*CMD_FUNC0195
    Gosub *FUNC_0195
Return
*CMD_FUNC0196
    Gosub *FUNC_0196
Return
*CMD_FUNC0197
    Gosub *FUNC_0197
Return
*CMD_FUNC0198
    Gosub *FUNC_0198
Return
*CMD_FUNC0199
    Gosub *FUNC_0199
Return
*CMD_FUNC0200
    Gosub *FUNC_0200
Return
*CMD_FUNC0201
    Gosub *FUNC_0201
Return
*CMD_FUNC0202
    Gosub *FUNC_0202
Return
*CMD_FUNC0203
    Gosub *FUNC_0203
Return
*CMD_FUNC0204
    Gosub *FUNC_0204
Return
*CMD_FUNC0205
    Gosub *FUNC_0205
Return
*CMD_FUNC0206
    Gosub *FUNC_0206
Return
*CMD_FUNC0207
    Gosub *FUNC_0207
Return
*CMD_FUNC0208
    Gosub *FUNC_0208
Return
*CMD_FUNC0209
    Gosub *FUNC_0209
Return
*CMD_FUNC0210
    Gosub *FUNC_0210
Return
*CMD_FUNC0211
    Gosub *FUNC_0211
Return
*CMD_FUNC0212
    Gosub *FUNC_0212
Return
*CMD_FUNC0213
    Gosub *FUNC_0213
Return
*CMD_FUNC0214
    Gosub *FUNC_0214
Return
*CMD_FUNC0215
    Gosub *FUNC_0215
Return
*CMD_FUNC0216
    Gosub *FUNC_0216
Return
*CMD_FUNC0217
    Gosub *FUNC_0217
Return
*CMD_FUNC0218
    Gosub *FUNC_0218
Return
*CMD_FUNC0219
    Gosub *FUNC_0219
Return
*CMD_FUNC0220
    Gosub *FUNC_0220
Return
*CMD_FUNC0221
    Gosub *FUNC_0221
Return
*CMD_FUNC0222
    Gosub *FUNC_0222
Return
*CMD_FUNC0223
    Gosub *FUNC_0223
Return
*CMD_FUNC0224
    Gosub *FUNC_0224
Return
*CMD_FUNC0225
    Gosub *FUNC_0225
Return
*CMD_FUNC0226
    Gosub *FUNC_0226
Return
*CMD_FUNC0227
    Gosub *FUNC_0227
Return
*CMD_FUNC0228
    Gosub *FUNC_0228
Return
*CMD_FUNC0229
    Gosub *FUNC_0229
Return
*CMD_FUNC0230
    Gosub *FUNC_0230
Return
*CMD_FUNC0231
    Gosub *FUNC_0231
Return
*CMD_FUNC0232
    Gosub *FUNC_0232
Return
*CMD_FUNC0233
    Gosub *FUNC_0233
Return
*CMD_FUNC0234
    Gosub *FUNC_0234
Return
*CMD_FUNC0235
    Gosub *FUNC_0235
Return
*CMD_FUNC0236
    Gosub *FUNC_0236
Return
*CMD_FUNC0237
    Gosub *FUNC_0237
Return
*CMD_FUNC0238
    Gosub *FUNC_0238
Return
*CMD_FUNC0239
    Gosub *FUNC_0239
Return
*CMD_FUNC0240
    Gosub *FUNC_0240
Return
*CMD_FUNC0241
    Gosub *FUNC_0241
Return
*CMD_FUNC0242
    Gosub *FUNC_0242
Return
*CMD_FUNC0243
    Gosub *FUNC_0243
Return
*CMD_FUNC0244
    Gosub *FUNC_0244
Return
*CMD_FUNC0245
    Gosub *FUNC_0245
Return
*CMD_FUNC0246
    Gosub *FUNC_0246
Return
*CMD_FUNC0247
    Gosub *FUNC_0247
Return
*CMD_FUNC0248
    Gosub *FUNC_0248
Return
*CMD_FUNC0249
    Gosub *FUNC_0249
Return
*CMD_FUNC0250
    Gosub *FUNC_0250
Return
*CMD_FUNC0251
    Gosub *FUNC_0251
Return
*CMD_FUNC0252
    Gosub *FUNC_0252
Return
*CMD_FUNC0253
    Gosub *FUNC_0253
Return
*CMD_FUNC0254
    Gosub *FUNC_0254
Return
*CMD_FUNC0255
    Gosub *FUNC_0255
Return
'! Function name table_End


'!Page

'!********************************************
'! Edited code
'! If you change this code without UI tool,
'! may not be able to open by UI tool.
'!********************************************
'! Dim ArgmentString$()
'! Dim ArgumentString$()
'! Dim ArgmentValue#()
'! Dim ArgumentValue#()
'! ArgmentsLength&
'! ArgumentsLength&
'! IoIdent$
'! CommandExecute&
'! ResponseCode&
'! Dim ResponseValue&()
'! ResponseString$

'! Command function_Start
*RBEXT_MOVE_JOG_PLUS_X'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_PLUS_X
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_X : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_X : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_TRANS_DIST##", LOC_TRANSDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_X : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_X : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = LOC_TRANSDIST#
IN_TRANSCOORD_OPEPOSY#  = 0
IN_TRANSCOORD_OPEPOSZ#  = 0
IN_TRANSCOORD_OPEPOSRX# = 0
IN_TRANSCOORD_OPEPOSRY# = 0
IN_TRANSCOORD_OPEPOSRZ# = 0

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_X : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_X : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_X : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_X : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_PLUS_X

*RBEXT_MOVE_JOG_MINUS_X'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_MINUS_X
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_X : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_X : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_TRANS_DIST##", LOC_TRANSDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_X : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_X : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = -LOC_TRANSDIST#
IN_TRANSCOORD_OPEPOSY#  = 0
IN_TRANSCOORD_OPEPOSZ#  = 0
IN_TRANSCOORD_OPEPOSRX# = 0
IN_TRANSCOORD_OPEPOSRY# = 0
IN_TRANSCOORD_OPEPOSRZ# = 0

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_X : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_X : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_X : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_X : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_MINUS_X

*RBEXT_MOVE_JOG_PLUS_Y'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_PLUS_Y
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_Y : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_Y : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_TRANS_DIST##", LOC_TRANSDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_Y : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_Y : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = 0
IN_TRANSCOORD_OPEPOSY#  = LOC_TRANSDIST#
IN_TRANSCOORD_OPEPOSZ#  = 0
IN_TRANSCOORD_OPEPOSRX# = 0
IN_TRANSCOORD_OPEPOSRY# = 0
IN_TRANSCOORD_OPEPOSRZ# = 0

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_Y : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_Y : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_Y : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_Y : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_PLUS_Y

*RBEXT_MOVE_JOG_MINUS_Y'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_MINUS_Y
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_Y : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_Y : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_TRANS_DIST##", LOC_TRANSDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_Y : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_Y : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = 0
IN_TRANSCOORD_OPEPOSY#  = -LOC_TRANSDIST#
IN_TRANSCOORD_OPEPOSZ#  = 0
IN_TRANSCOORD_OPEPOSRX# = 0
IN_TRANSCOORD_OPEPOSRY# = 0
IN_TRANSCOORD_OPEPOSRZ# = 0

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_Y : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_Y : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_Y : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_Y : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_MINUS_Y

*RBEXT_MOVE_JOG_PLUS_Z'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_PLUS_Z
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_Z : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_Z : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_TRANS_DIST##", LOC_TRANSDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_Z : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_Z : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = 0
IN_TRANSCOORD_OPEPOSY#  = 0
IN_TRANSCOORD_OPEPOSZ#  = LOC_TRANSDIST#
IN_TRANSCOORD_OPEPOSRX# = 0
IN_TRANSCOORD_OPEPOSRY# = 0
IN_TRANSCOORD_OPEPOSRZ# = 0

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_Z : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_Z : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_Z : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_PLUS_Z : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_PLUS_Z

*RBEXT_MOVE_JOG_MINUS_Z'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_MINUS_Z
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_Z : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_Z : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_TRANS_DIST##", LOC_TRANSDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_Z : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_Z : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = 0
IN_TRANSCOORD_OPEPOSY#  = 0
IN_TRANSCOORD_OPEPOSZ#  = -LOC_TRANSDIST#
IN_TRANSCOORD_OPEPOSRX# = 0
IN_TRANSCOORD_OPEPOSRY# = 0
IN_TRANSCOORD_OPEPOSRZ# = 0

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_Z : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_Z : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_Z : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_MOVE_JOG_MINUS_Z : " + DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_MINUS_Z

*RBEXT_MOVE_JOG_PLUS_RX'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_PLUS_RX
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RX : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RX : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0
LOC_EULER&     = 0
LOC_COSYS&     = 0
LOC_TYPE&      = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_ROT_DIST##", LOC_ROTDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&
GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RX : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RX : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = 0
IN_TRANSCOORD_OPEPOSY#  = 0
IN_TRANSCOORD_OPEPOSZ#  = 0

Select LOC_TYPE&
Case 2
  IN_TRANSCOORD_OPEPOSRX# = LOC_ROTDIST#
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = 0

Case Else
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = 0

End Select

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RX : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RX : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RX : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RX : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_PLUS_RX

*RBEXT_MOVE_JOG_MINUS_RX'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_MINUS_RX
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RX : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RX : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0
LOC_EULER&     = 0
LOC_COSYS&     = 0
LOC_TYPE&      = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_ROT_DIST##", LOC_ROTDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&
GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RX : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RX : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = 0
IN_TRANSCOORD_OPEPOSY#  = 0
IN_TRANSCOORD_OPEPOSZ#  = 0

Select LOC_TYPE&
Case 2
  IN_TRANSCOORD_OPEPOSRX# = -LOC_ROTDIST#
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = 0

Case Else
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = 0

End Select

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RX : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RX : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RX : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RX : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_MINUS_RX

*RBEXT_MOVE_JOG_PLUS_RY'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_PLUS_RY            
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RY : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RY : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0
LOC_EULER&     = 0
LOC_COSYS&     = 0
LOC_TYPE&      = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_ROT_DIST##", LOC_ROTDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&
GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RY : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RY : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = 0
IN_TRANSCOORD_OPEPOSY#  = 0
IN_TRANSCOORD_OPEPOSZ#  = 0

Select LOC_TYPE&
Case 2
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = LOC_ROTDIST#
  IN_TRANSCOORD_OPEPOSRZ# = 0

Case Else
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = 0

End Select

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RY : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RY : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RY : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RY : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_PLUS_RY

*RBEXT_MOVE_JOG_MINUS_RY'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_MINUS_RY
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RY : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RY : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0
LOC_EULER&     = 0
LOC_COSYS&     = 0
LOC_TYPE&      = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_ROT_DIST##", LOC_ROTDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&
GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RY : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RY : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = 0
IN_TRANSCOORD_OPEPOSY#  = 0
IN_TRANSCOORD_OPEPOSZ#  = 0

Select LOC_TYPE&
Case 2
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = -LOC_ROTDIST#
  IN_TRANSCOORD_OPEPOSRZ# = 0

Case Else
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = 0

End Select

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RY : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RY : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RY : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RY : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_MINUS_RY

*RBEXT_MOVE_JOG_PLUS_RZ'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_PLUS_RZ
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RZ : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RZ : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0
LOC_EULER&     = 0
LOC_COSYS&     = 0
LOC_TYPE&      = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_ROT_DIST##", LOC_ROTDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&
GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RZ : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RZ : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = 0
IN_TRANSCOORD_OPEPOSY#  = 0
IN_TRANSCOORD_OPEPOSZ#  = 0

Select LOC_TYPE&
Case 1
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = LOC_ROTDIST#

Case 2
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = LOC_ROTDIST#

Case Else
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = 0

End Select

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RZ : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RZ : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return
EndIf

'--------------
' ロボット移動
'--------------
LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_PLUS_RZ : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_PLUS_RZ : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_PLUS_RZ

*RBEXT_MOVE_JOG_MINUS_RZ'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_JOG_MINUS_RZ
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RZ : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RZ : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0
LOC_EULER&     = 0
LOC_COSYS&     = 0
LOC_TYPE&      = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

GetSystemData "Macro_SY", "RBVAR_ROT_DIST##", LOC_ROTDIST#
GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_COSYS&&", LOC_COSYS&
GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RZ : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RZ : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_TRANSCOORD_EULER&    = LOC_EULER&
IN_TRANSCOORD_COSYS&    = LOC_COSYS&

IN_TRANSCOORD_SRCPOSX#  = LOC_CURPOSX#
IN_TRANSCOORD_SRCPOSY#  = LOC_CURPOSY#
IN_TRANSCOORD_SRCPOSZ#  = LOC_CURPOSZ#
IN_TRANSCOORD_SRCPOSW#  = LOC_CURPOSW#
IN_TRANSCOORD_SRCPOSP#  = LOC_CURPOSP#
IN_TRANSCOORD_SRCPOSR#  = LOC_CURPOSR#

IN_TRANSCOORD_OPEPOSX#  = 0
IN_TRANSCOORD_OPEPOSY#  = 0
IN_TRANSCOORD_OPEPOSZ#  = 0

Select LOC_TYPE&
Case 1
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = -LOC_ROTDIST#

Case 2
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = -LOC_ROTDIST#

Case Else
  IN_TRANSCOORD_OPEPOSRX# = 0
  IN_TRANSCOORD_OPEPOSRY# = 0
  IN_TRANSCOORD_OPEPOSRZ# = 0

End Select

Gosub *RBINT_TRANS_COORD

If OUT_TRANSCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RZ : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RZ : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_TRANSCOORD_DSTPOSX#
LOC_CMDPOSY# = OUT_TRANSCOORD_DSTPOSY#
LOC_CMDPOSZ# = OUT_TRANSCOORD_DSTPOSZ#
LOC_CMDPOSW# = OUT_TRANSCOORD_DSTPOSW#
LOC_CMDPOSP# = OUT_TRANSCOORD_DSTPOSP#
LOC_CMDPOSR# = OUT_TRANSCOORD_DSTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_JOG_MINUS_RZ : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_JOG_MINUS_RZ : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_JOG_MINUS_RZ

*RBEXT_MOVE_DST_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_DST_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_DST_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_DST_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_EULER&     = 0
LOC_TYPE&      = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_DSTPOSX# = 0
LOC_DSTPOSY# = 0
LOC_DSTPOSR# = 0
LOC_DSTPOSW# = 0
LOC_DSTPOSP# = 0
LOC_DSTPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

LOC_DISTANCE#  = 0

GetSystemData "Macro_SY", "RBVAR_POSE_ROT_TYPE&&", LOC_EULER&
GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

GetSystemData "Macro_SY", "RBVAR_DST_POS_X##", LOC_DSTPOSX#
GetSystemData "Macro_SY", "RBVAR_DST_POS_Y##", LOC_DSTPOSY#
GetSystemData "Macro_SY", "RBVAR_DST_POS_Z##", LOC_DSTPOSZ#
GetSystemData "Macro_SY", "RBVAR_DST_POS_W##", LOC_DSTPOSW#
GetSystemData "Macro_SY", "RBVAR_DST_POS_P##", LOC_DSTPOSP#
GetSystemData "Macro_SY", "RBVAR_DST_POS_R##", LOC_DSTPOSR#

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_DST_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_DST_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

IN_CALCDSTPOS_EULER&   = LOC_EULER&

IN_CALCDSTPOS_SRCPOSX# = LOC_CURPOSX#
IN_CALCDSTPOS_SRCPOSY# = LOC_CURPOSY#
IN_CALCDSTPOS_SRCPOSZ# = LOC_CURPOSZ#
IN_CALCDSTPOS_SRCPOSW# = LOC_CURPOSW#
IN_CALCDSTPOS_SRCPOSP# = LOC_CURPOSP#
IN_CALCDSTPOS_SRCPOSR# = LOC_CURPOSR#

IN_CALCDSTPOS_DSTPOSX# = LOC_DSTPOSX#
IN_CALCDSTPOS_DSTPOSY# = LOC_DSTPOSY#
IN_CALCDSTPOS_DSTPOSZ# = LOC_DSTPOSZ#

Select LOC_TYPE&
Case 1
  IN_CALCDSTPOS_DSTPOSW# = LOC_CURPOSW#
  IN_CALCDSTPOS_DSTPOSP# = LOC_CURPOSP#
  IN_CALCDSTPOS_DSTPOSR# = LOC_DSTPOSR#

Case 2
  IN_CALCDSTPOS_DSTPOSW# = LOC_DSTPOSW#
  IN_CALCDSTPOS_DSTPOSP# = LOC_DSTPOSP#
  IN_CALCDSTPOS_DSTPOSR# = LOC_DSTPOSR#

Case Else
  IN_CALCDSTPOS_DSTPOSW# = LOC_CURPOSW#
  IN_CALCDSTPOS_DSTPOSP# = LOC_CURPOSP#
  IN_CALCDSTPOS_DSTPOSR# = LOC_CURPOSR#

End Select

Gosub *RBINT_CALC_DST_POS

If OUT_CALCDSTPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_DST_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_DST_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CMDPOSX# = OUT_CALCDSTPOS_CALCPOSX#
LOC_CMDPOSY# = OUT_CALCDSTPOS_CALCPOSY#
LOC_CMDPOSZ# = OUT_CALCDSTPOS_CALCPOSZ#
LOC_CMDPOSW# = OUT_CALCDSTPOS_CALCPOSW#
LOC_CMDPOSP# = OUT_CALCDSTPOS_CALCPOSP#
LOC_CMDPOSR# = OUT_CALCDSTPOS_CALCPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_DST_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_DST_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_DST_POS

*RBEXT_MOVE_CAL_STR_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_CAL_STR_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_CAL_STR_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_CAL_STR_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

LOC_TYPE&    = 0

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_CAL_STR_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_CAL_STR_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

GetSceneData "RBVAR_CAL_STR_POS_X##", LOC_CMDPOSX#
GetSceneData "RBVAR_CAL_STR_POS_Y##", LOC_CMDPOSY#
GetSceneData "RBVAR_CAL_STR_POS_Z##", LOC_CMDPOSZ#
GetSceneData "RBVAR_CAL_STR_POS_W##", LOC_CMDPOSW#
GetSceneData "RBVAR_CAL_STR_POS_P##", LOC_CMDPOSP#
GetSceneData "RBVAR_CAL_STR_POS_R##", LOC_CMDPOSR#

GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#

Select LOC_TYPE&
Case 1
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case 2
  IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
  IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case Else
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CURPOSR#

End Select

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_CAL_STR_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_CAL_STR_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_CAL_STR_POS

*RBEXT_MOVE_STD_GRP_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_STD_GRP_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_STD_GRP_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_STD_GRP_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

LOC_TYPE&    = 0

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_STD_GRP_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_STD_GRP_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

GetSceneData "RBVAR_STD_GRP_POS_X##", LOC_CMDPOSX#
GetSceneData "RBVAR_STD_GRP_POS_Y##", LOC_CMDPOSY#
GetSceneData "RBVAR_STD_GRP_POS_Z##", LOC_CMDPOSZ#
GetSceneData "RBVAR_STD_GRP_POS_W##", LOC_CMDPOSW#
GetSceneData "RBVAR_STD_GRP_POS_P##", LOC_CMDPOSP#
GetSceneData "RBVAR_STD_GRP_POS_R##", LOC_CMDPOSR#

GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#

Select LOC_TYPE&
Case 1
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case 2
  IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
  IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case Else
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CURPOSR#

End Select

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_STD_GRP_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_STD_GRP_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_STD_GRP_POS

*RBEXT_MOVE_STD_IMG_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_STD_IMG_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_STD_IMG_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_STD_IMG_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

LOC_TYPE&    = 0

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_STD_IMG_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_STD_IMG_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

GetSceneData "RBVAR_STD_IMG_POS_X##", LOC_CMDPOSX#
GetSceneData "RBVAR_STD_IMG_POS_Y##", LOC_CMDPOSY#
GetSceneData "RBVAR_STD_IMG_POS_Z##", LOC_CMDPOSZ#
GetSceneData "RBVAR_STD_IMG_POS_W##", LOC_CMDPOSW#
GetSceneData "RBVAR_STD_IMG_POS_P##", LOC_CMDPOSP#
GetSceneData "RBVAR_STD_IMG_POS_R##", LOC_CMDPOSR#

GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#

Select LOC_TYPE&
Case 1
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case 2
  IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
  IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case Else
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CURPOSR#

End Select

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_STD_IMG_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_STD_IMG_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_STD_IMG_POS

*RBEXT_MOVE_RES_CMD_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_RES_CMD_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_RES_CMD_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_RES_CMD_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

LOC_TYPE&    = 0

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_RES_CMD_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_RES_CMD_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_X#", LOC_CMDPOSX#
GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_Y#", LOC_CMDPOSY#
GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_Z#", LOC_CMDPOSZ#
GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_W#", LOC_CMDPOSW#
GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_P#", LOC_CMDPOSP#
GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_R#", LOC_CMDPOSR#

GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#

Select LOC_TYPE&
Case 1
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case 2
  IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
  IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case Else
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CURPOSR#

End Select

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_RES_CMD_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_RES_CMD_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_RES_CMD_POS

*RBEXT_EXEC_AUTO_CALIB_ALL'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_EXEC_AUTO_CALIB_ALL
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_EXEC_AUTO_CALIB_ALL : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_EXEC_AUTO_CALIB_ALL : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

Do

  Gosub *RBINT_EXEC_AUTO_CALIB_STEP

  If OUT_EXECCALIB_RET& <> 0 Then
    '--------------------
    '  Error
    '--------------------
    Print "ERROR : RBEXT_EXEC_AUTO_CALIB_ALL : ", DEF_ERRMSG_PROCFAILED$
    LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_EXEC_AUTO_CALIB_ALL : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

    Gosub *RBINT_FINAL
    Return

  EndIf

  LOC_CALJDG&    = OUT_EXECCALIB_CALJDG&
  LOC_CALENDFLG& = OUT_EXECCALIB_CALENDFLG&

  Wait 3000

Loop While LOC_CALJDG& = 1 AND LOC_CALENDFLG& = 0

LOC_CURPOSX# = OUT_EXECCALIB_CURPOSX#
LOC_CURPOSY# = OUT_EXECCALIB_CURPOSY#
LOC_CURPOSZ# = OUT_EXECCALIB_CURPOSZ#
LOC_CURPOSW# = OUT_EXECCALIB_CURPOSW#
LOC_CURPOSP# = OUT_EXECCALIB_CURPOSP#
LOC_CURPOSR# = OUT_EXECCALIB_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_EXEC_AUTO_CALIB_ALL

*RBEXT_EXEC_AUTO_CALIB_STEP'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_EXEC_AUTO_CALIB_STEP
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_EXEC_AUTO_CALIB_STEP : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBEXT_EXEC_AUTO_CALIB_STEP : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

Gosub *RBINT_EXEC_AUTO_CALIB_STEP

If OUT_EXECCALIB_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_EXEC_AUTO_CALIB_STEP : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_EXEC_AUTO_CALIB_STEP : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_EXECCALIB_CURPOSX#
LOC_CURPOSY# = OUT_EXECCALIB_CURPOSY#
LOC_CURPOSZ# = OUT_EXECCALIB_CURPOSZ#
LOC_CURPOSW# = OUT_EXECCALIB_CURPOSW#
LOC_CURPOSP# = OUT_EXECCALIB_CURPOSP#
LOC_CURPOSR# = OUT_EXECCALIB_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_EXEC_AUTO_CALIB_STEP

*RBEXT_SET_CAL_STR_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_SET_CAL_STR_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_SET_CAL_STR_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_SET_CAL_STR_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

GetSystemData "Macro_SY","RBVAR_CUR_POS_X#", LOC_CURPOSX#
GetSystemData "Macro_SY","RBVAR_CUR_POS_Y#", LOC_CURPOSY#
GetSystemData "Macro_SY","RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
GetSystemData "Macro_SY","RBVAR_CUR_POS_W#", LOC_CURPOSW#
GetSystemData "Macro_SY","RBVAR_CUR_POS_P#", LOC_CURPOSP#
GetSystemData "Macro_SY","RBVAR_CUR_POS_R#", LOC_CURPOSR#

SetSceneData "RBVAR_CAL_STR_POS_X##", LOC_CURPOSX#
SetSceneData "RBVAR_CAL_STR_POS_Y##", LOC_CURPOSY#
SetSceneData "RBVAR_CAL_STR_POS_Z##", LOC_CURPOSZ#
SetSceneData "RBVAR_CAL_STR_POS_W##", LOC_CURPOSW#
SetSceneData "RBVAR_CAL_STR_POS_P##", LOC_CURPOSP#
SetSceneData "RBVAR_CAL_STR_POS_R##", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_SET_CAL_STR_POS

*RBEXT_SET_STD_GRP_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_SET_STD_GRP_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_SET_STD_GRP_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_SET_STD_GRP_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

GetSystemData "Macro_SY","RBVAR_CUR_POS_X#", LOC_CURPOSX#
GetSystemData "Macro_SY","RBVAR_CUR_POS_Y#", LOC_CURPOSY#
GetSystemData "Macro_SY","RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
GetSystemData "Macro_SY","RBVAR_CUR_POS_W#", LOC_CURPOSW#
GetSystemData "Macro_SY","RBVAR_CUR_POS_P#", LOC_CURPOSP#
GetSystemData "Macro_SY","RBVAR_CUR_POS_R#", LOC_CURPOSR#

SetSceneData "RBVAR_STD_GRP_POS_X##", LOC_CURPOSX#
SetSceneData "RBVAR_STD_GRP_POS_Y##", LOC_CURPOSY#
SetSceneData "RBVAR_STD_GRP_POS_Z##", LOC_CURPOSZ#
SetSceneData "RBVAR_STD_GRP_POS_W##", LOC_CURPOSW#
SetSceneData "RBVAR_STD_GRP_POS_P##", LOC_CURPOSP#
SetSceneData "RBVAR_STD_GRP_POS_R##", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_SET_STD_GRP_POS

*RBEXT_SET_STD_IMG_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_SET_STD_IMG_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_SET_STD_IMG_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_SET_STD_IMG_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

GetSystemData "Macro_SY","RBVAR_CUR_POS_X#", LOC_CURPOSX#
GetSystemData "Macro_SY","RBVAR_CUR_POS_Y#", LOC_CURPOSY#
GetSystemData "Macro_SY","RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
GetSystemData "Macro_SY","RBVAR_CUR_POS_W#", LOC_CURPOSW#
GetSystemData "Macro_SY","RBVAR_CUR_POS_P#", LOC_CURPOSP#
GetSystemData "Macro_SY","RBVAR_CUR_POS_R#", LOC_CURPOSR#

SetSceneData "RBVAR_STD_IMG_POS_X##", LOC_CURPOSX#
SetSceneData "RBVAR_STD_IMG_POS_Y##", LOC_CURPOSY#
SetSceneData "RBVAR_STD_IMG_POS_Z##", LOC_CURPOSZ#
SetSceneData "RBVAR_STD_IMG_POS_W##", LOC_CURPOSW#
SetSceneData "RBVAR_STD_IMG_POS_P##", LOC_CURPOSP#
SetSceneData "RBVAR_STD_IMG_POS_R##", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_SET_STD_IMG_POS

*RBEXT_SET_STD_WRK_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_SET_STD_WRK_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_SET_STD_WRK_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_SET_STD_WRK_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_WRKPOSX# = 0
LOC_WRKPOSY# = 0
LOC_WRKPOST# = 0

GetSystemData "Macro_SY", "RBVAR_RES_WRK_POS_X#", LOC_WRKPOSX#
GetSystemData "Macro_SY", "RBVAR_RES_WRK_POS_Y#", LOC_WRKPOSY#
GetSystemData "Macro_SY", "RBVAR_RES_WRK_POS_T#", LOC_WRKPOST#

SetSceneData "RBVAR_STD_WRK_POS_X##", LOC_WRKPOSX#
SetSceneData "RBVAR_STD_WRK_POS_Y##", LOC_WRKPOSY#
SetSceneData "RBVAR_STD_WRK_POS_T##", LOC_WRKPOST#

Gosub *RBINT_FINAL
Return'!RBEXT_SET_STD_WRK_POS

*RBEXT_GET_CUR_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_GET_CUR_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_GET_CUR_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_GET_CUR_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_TRANSDIST# = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_GET_CUR_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_GET_CUR_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_GET_CUR_POS

*RBINT_INIT'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_INIT
' **********************************************************************
MeasureStop

OUT_INIT_RET&  = 0

DEF_MCRVER$    = "1.01"
DEF_PREFIX$    = "RCMD"
DEF_SPLIT$     = " "
DEF_ECHO&      = 1
DEF_SETPARAM&  = 10
DEF_GETCURPOS& = 12
DEF_GETVERINF& = 13
DEF_ABSMOVE&   = 100
DEF_CR&        = 13

DEF_TCPNORMAL$ = "TcpNormal"

DEF_SENDRECVMOD# = 10000

DEF_PI#  = 3.14159265358979
DEF_ZYX& = 0
DEF_ZYZ& = 1

DEF_WORLD& = 0
DEF_TOOL&  = 1


DEF_ERRMSG_PROCFAILED$  = "Processing failed"
DEF_ERRMSG_SENDSTRING$  = "SendString failed"
DEF_ERRMSG_RECEIVEDATA$ = "ReceiveData failed"
DEF_ERRMSG_MEASURE$     = "Measure failed"

DEF_ERRMSG_TIMEOUT$     = "Timeout error"
DEF_ERRMSG_INVALID$     = "Invalid value error"
DEF_ERRMSG_IDNONCOIN$   = "Command ID mismatch"

DEF_ERRMSG_JUDGE$       = "Judge NG"

DEF_ERRMSG_ERRORRET$    = "Error returned"

DEF_ERRLOG_SPRT$ = ";"
DEF_ERRLOG_MSG_NUM& = 5

LOC_ERRLOG_MSG$ = ""


SetSystemData "Macro_SY", "RBVAR_ERR_FLAG&", 0
SetSystemData "Macro_SY", "RBVAR_ERR_MSG$(0)", ""
SetSystemData "Macro_SY", "RBVAR_ERR_MSG$(1)", ""
SetSystemData "Macro_SY", "RBVAR_ERR_MSG$(2)", ""
SetSystemData "Macro_SY", "RBVAR_ERR_MSG$(3)", ""
SetSystemData "Macro_SY", "RBVAR_ERR_MSG$(4)", ""


Gosub *RBINT_GET_VER_INF

If OUT_GETVERINF_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_INIT : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_INIT : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_INIT_RET& = -1
  Return

EndIf

SetSystemData "Macro_SY", "RBVAR_MCR_VER$$", DEF_MCRVER$
SetSystemData "Macro_SY", "RBVAR_PRG_VER$$", OUT_GETVERINF_PRGVER$
Return'!RBINT_INIT

*RBINT_FINAL'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_FINAL
' **********************************************************************

LOC_ERRLOG_STR$ = ""
LOC_ERRLOG_MSG_NAME$ = ""

If LOC_ERRLOG_MSG$ = "" Then
 SetSystemData "Macro_SY", "RBVAR_ERR_FLAG&", 0

Else
 SetSystemData "Macro_SY", "RBVAR_ERR_FLAG&", 1
 For  I& = 1  To  DEF_ERRLOG_MSG_NUM&
  LOC_ERRLOG_STR$ = Piece$(LOC_ERRLOG_MSG$,DEF_ERRLOG_SPRT$,I&,I&)
  LOC_ERRLOG_MSG_NAME$ = "RBVAR_ERR_MSG$(" + Str$(I& - 1) + ")"
  SetSystemData "Macro_SY",LOC_ERRLOG_MSG_NAME$, LOC_ERRLOG_STR$
 Next 
EndIf

RaiseOptionEvent 480, 10000

MeasureStart
Return'!RBINT_FINAL

*RBINT_EXEC_COMMAND'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_EXEC_COMMAND
' **********************************************************************

Dim LOC_BUFFDATA&(127)
Dim LOC_BYTEDATA&(4)

OUT_EXECCMD_RET&     = 0
OUT_EXECCMD_CURPOSX# = 0
OUT_EXECCMD_CURPOSY# = 0
OUT_EXECCMD_CURPOSZ# = 0
OUT_EXECCMD_CURPOSW# = 0
OUT_EXECCMD_CURPOSP# = 0
OUT_EXECCMD_CURPOSR# = 0

LOC_CMDID&     = IN_EXECCMD_CMDID&
LOC_TIMEOUT&   = IN_EXECCMD_TIMEOUT&

LOC_SPEED&     = IN_EXECCMD_SPEED&
LOC_ACCEL&     = 100

LOC_CMDPOSX#   = IN_EXECCMD_CMDPOSX#
LOC_CMDPOSY#   = IN_EXECCMD_CMDPOSY#
LOC_CMDPOSZ#   = IN_EXECCMD_CMDPOSZ#

LOC_CMDPOSW#   = IN_EXECCMD_CMDPOSW#
LOC_CMDPOSP#   = IN_EXECCMD_CMDPOSP#
LOC_CMDPOSR#   = IN_EXECCMD_CMDPOSR#

LOC_CURPOSX#   = 0
LOC_CURPOSY#   = 0
LOC_CURPOSZ#   = 0
LOC_CURPOSW#   = 0
LOC_CURPOSP#   = 0
LOC_CURPOSR#   = 0

LOC_IOMODULE$  = DEF_TCPNORMAL$
LOC_SENDDATA$  = ""
LOC_RECVDATA$  = ""
LOC_TEMPDATA&  = 0

LOC_I&         = 0
LOC_J&         = 0
LOC_DATASIZE&  = 0
LOC_TIMESTART# = 0
LOC_TIME&      = 0

LOC_RESID&     = 0
LOC_RET&       = 0

LOC_SENDDATA$ = DEF_PREFIX$ + DEF_SPLIT$ + Str$(LOC_CMDID&)

Select LOC_CMDID&
Case DEF_ECHO&

Case DEF_SETPARAM&

  LOC_SENDDATA$ = LOC_SENDDATA$ + DEF_SPLIT$ + Str$(LOC_SPEED&)

Case DEF_GETCURPOS&

Case DEF_GETVERINF&

Case DEF_ABSMOVE&

  LOC_SENDDATA$ = LOC_SENDDATA$ + DEF_SPLIT$ + Str2$(LOC_CMDPOSX# * DEF_SENDRECVMOD#, 0, 0, 0, 0)
  LOC_SENDDATA$ = LOC_SENDDATA$ + DEF_SPLIT$ + Str2$(LOC_CMDPOSY# * DEF_SENDRECVMOD#, 0, 0, 0, 0)
  LOC_SENDDATA$ = LOC_SENDDATA$ + DEF_SPLIT$ + Str2$(LOC_CMDPOSZ# * DEF_SENDRECVMOD#, 0, 0, 0, 0)
  LOC_SENDDATA$ = LOC_SENDDATA$ + DEF_SPLIT$ + Str2$(LOC_CMDPOSW# * DEF_SENDRECVMOD#, 0, 0, 0, 0)
  LOC_SENDDATA$ = LOC_SENDDATA$ + DEF_SPLIT$ + Str2$(LOC_CMDPOSP# * DEF_SENDRECVMOD#, 0, 0, 0, 0)
  LOC_SENDDATA$ = LOC_SENDDATA$ + DEF_SPLIT$ + Str2$(LOC_CMDPOSR# * DEF_SENDRECVMOD#, 0, 0, 0, 0)

End Select

Try

  SendString LOC_IOMODULE$, LOC_SENDDATA$

Catch
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_EXEC_COMMAND : ", DEF_ERRMSG_SENDSTRING$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_EXEC_COMMAND : " +  DEF_ERRMSG_SENDSTRING$ + DEF_ERRLOG_SPRT$

  OUT_EXECCMD_RET& = -1
  Return

End Try

SetPollingState LOC_IOMODULE$, False

LOC_TIMESTART# = StartTimer

Try

  Do
    ReceiveData LOC_IOMODULE$, LOC_BUFFDATA&(), (4 * 128), LOC_DATASIZE&

    LOC_TIME& = Timer(LOC_TIMESTART#, 0)

  Loop While (LOC_DATASIZE& = 0 AND LOC_TIME& < LOC_TIMEOUT&)

  If (LOC_TIME& >= LOC_TIMEOUT&) Then
  '--------------------
  '  Error
  '--------------------
    Print "ERROR : RBINT_EXEC_COMMAND : ", DEF_ERRMSG_TIMEOUT$
    LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +    "ERROR : RBINT_EXEC_COMMAND : " +  DEF_ERRMSG_TIMEOUT$ + DEF_ERRLOG_SPRT$

    SetPollingState LOC_IOMODULE$, True

    OUT_EXECCMD_RET& = -1
    Return

  EndIf

  SetPollingState LOC_IOMODULE$, True

Catch
  If GetPollingState(LOC_IOMODULE$) = False Then
    '--------------------
    '  Error
    '--------------------
    Print "ERROR : RBINT_EXEC_COMMAND : ", DEF_ERRMSG_RECEIVEDATA$
    LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +    "ERROR : RBINT_EXEC_COMMAND : " +  DEF_ERRMSG_RECEIVEDATA$ + DEF_ERRLOG_SPRT$

    SetPollingState LOC_IOMODULE$, True

    OUT_EXECCMD_RET& = -1
    Return

  EndIf
End Try

For LOC_I& = 0 To LOC_DATASIZE& Then

  LOC_TEMPDATA& = Int(LOC_BUFFDATA&(LOC_I&))

  LOC_MSB& = LOC_TEMPDATA& AND -2147483648

  LOC_TEMPDATA& = LOC_TEMPDATA& AND 2147483647

  LOC_BYTEDATA&(0) = LOC_TEMPDATA& AND 255
  LOC_TEMPDATA&    = LOC_TEMPDATA&  /  256
  LOC_BYTEDATA&(1) = LOC_TEMPDATA& AND 255
  LOC_TEMPDATA&    = LOC_TEMPDATA&  /  256
  LOC_BYTEDATA&(2) = LOC_TEMPDATA& AND 255
  LOC_TEMPDATA&    = LOC_TEMPDATA&  /  256
  LOC_BYTEDATA&(3) = LOC_TEMPDATA& AND 255

   If (LOC_MSB& <> 0) Then

     LOC_BYTEDATA&(3) = LOC_BYTEDATA&(3) OR 128

   EndIf

   For LOC_J& = 0 To 3 Then

     LOC_TEMPDATA& = LOC_BYTEDATA&(LOC_J&)

     If LOC_TEMPDATA& = DEF_CR& Then

       Exit For

     Else

       LOC_RECVDATA$ = LOC_RECVDATA$ + Chr$(LOC_TEMPDATA&)

     EndIf
   Next

   If LOC_TEMPDATA& = DEF_CR& Then

      Exit For

   EndIf
Next

LOC_RESID&     = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 2,2))
LOC_RET&       = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 3,3))

If LOC_RESID& <> LOC_CMDID& Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_EXEC_COMMAND : ", DEF_ERRMSG_IDNONCOIN$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_EXEC_COMMAND : " +  DEF_ERRMSG_IDNONCOIN$ + DEF_ERRLOG_SPRT$

  OUT_EXECCMD_RET& = -1
  Return

EndIf

If LOC_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_EXEC_COMMAND : ", DEF_ERRMSG_ERRORRET$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_EXEC_COMMAND : " +  DEF_ERRMSG_ERRORRET$ + DEF_ERRLOG_SPRT$

  OUT_EXECCMD_RET& = -1
  Return

EndIf

Select LOC_RESID&
Case DEF_ECHO&

Case DEF_SETPARAM&

Case DEF_GETCURPOS&

  LOC_CURPOSX# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 4,4))
  LOC_CURPOSY# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 5,5))
  LOC_CURPOSZ# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 6,6))
  LOC_CURPOSW# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 7,7))
  LOC_CURPOSP# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 8,8))
  LOC_CURPOSR# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 9,9))

  OUT_EXECCMD_CURPOSX# = LOC_CURPOSX# / DEF_SENDRECVMOD#
  OUT_EXECCMD_CURPOSY# = LOC_CURPOSY# / DEF_SENDRECVMOD#
  OUT_EXECCMD_CURPOSZ# = LOC_CURPOSZ# / DEF_SENDRECVMOD#
  OUT_EXECCMD_CURPOSW# = LOC_CURPOSW# / DEF_SENDRECVMOD#
  OUT_EXECCMD_CURPOSP# = LOC_CURPOSP# / DEF_SENDRECVMOD#
  OUT_EXECCMD_CURPOSR# = LOC_CURPOSR# / DEF_SENDRECVMOD#

Case DEF_GETVERINF&

  OUT_EXECCMD_PRGVER$ = Piece$(LOC_RECVDATA$, DEF_SPLIT$, 4,4)

Case DEF_ABSMOVE&

  LOC_CURPOSX# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 4,4))
  LOC_CURPOSY# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 5,5))
  LOC_CURPOSZ# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 6,6))
  LOC_CURPOSW# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 7,7))
  LOC_CURPOSP# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 8,8))
  LOC_CURPOSR# = Val(Piece$(LOC_RECVDATA$, DEF_SPLIT$, 9,9))

  OUT_EXECCMD_CURPOSX# = LOC_CURPOSX# / DEF_SENDRECVMOD#
  OUT_EXECCMD_CURPOSY# = LOC_CURPOSY# / DEF_SENDRECVMOD#
  OUT_EXECCMD_CURPOSZ# = LOC_CURPOSZ# / DEF_SENDRECVMOD#
  OUT_EXECCMD_CURPOSW# = LOC_CURPOSW# / DEF_SENDRECVMOD#
  OUT_EXECCMD_CURPOSP# = LOC_CURPOSP# / DEF_SENDRECVMOD#
  OUT_EXECCMD_CURPOSR# = LOC_CURPOSR# / DEF_SENDRECVMOD#

End Select
Return'!RBINT_EXEC_COMMAND

*RBINT_CONV_ROT_COORD_TO_MAT'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_CONV_ROT_COORD_TO_MAT
' **********************************************************************

OUT_CONVROTCOORD_RET& = 0

LOC_EULER& = IN_CONVROTCOORD_EULER&

LOC_W# = IN_CONVROTCOORD_W# * DEF_PI# / 180
LOC_P# = IN_CONVROTCOORD_P# * DEF_PI# / 180
LOC_R# = IN_CONVROTCOORD_R# * DEF_PI# / 180

Select LOC_EULER&
Case DEF_ZYX&

  LOC_A# = LOC_R#
  LOC_B# = LOC_P#
  LOC_C# = LOC_W#

  LOC_T00# =  Cos(LOC_B#)*Cos(LOC_A#)
  LOC_T01# =  Sin(LOC_C#)*Sin(LOC_B#)*Cos(LOC_A#) - Cos(LOC_C#)*Sin(LOC_A#)
  LOC_T02# =  Cos(LOC_C#)*Sin(LOC_B#)*Cos(LOC_A#) + Sin(LOC_C#)*Sin(LOC_A#)

  LOC_T10# =  Cos(LOC_B#)*Sin(LOC_A#)
  LOC_T11# =  Sin(LOC_C#)*Sin(LOC_B#)*Sin(LOC_A#) + Cos(LOC_C#)*Cos(LOC_A#)
  LOC_T12# =  Cos(LOC_C#)*Sin(LOC_B#)*Sin(LOC_A#) - Sin(LOC_C#)*Cos(LOC_A#)

  LOC_T20# = -Sin(LOC_B#)
  LOC_T21# =  Sin(LOC_C#)*Cos(LOC_B#)
  LOC_T22# =  Cos(LOC_C#)*Cos(LOC_B#)

Case DEF_ZYZ&

  LOC_A# = LOC_W#
  LOC_B# = LOC_P#
  LOC_C# = LOC_R#

  LOC_T00# =  Cos(LOC_B#)*Cos(LOC_A#)*Cos(LOC_C#) - Sin(LOC_A#)*Sin(LOC_C#)
  LOC_T01# = -Cos(LOC_B#)*Sin(LOC_C#)*Cos(LOC_A#) - Sin(LOC_A#)*Cos(LOC_C#)
  LOC_T02# =  Sin(LOC_B#)*Cos(LOC_A#)

  LOC_T10# =  Cos(LOC_B#)*Sin(LOC_A#)*Cos(LOC_C#) + Sin(LOC_C#)*Cos(LOC_A#)
  LOC_T11# = -Cos(LOC_B#)*Sin(LOC_A#)*Sin(LOC_C#) + Cos(LOC_A#)*Cos(LOC_C#)
  LOC_T12# =  Sin(LOC_B#)*Sin(LOC_A#)

  LOC_T20# = -Sin(LOC_B#)*Cos(LOC_C#)
  LOC_T21# =  Sin(LOC_B#)*Sin(LOC_C#)
  LOC_T22# =  Cos(LOC_B#)

Case Else

End Select

OUT_CONVROTCOORD_T00# = LOC_T00#
OUT_CONVROTCOORD_T01# = LOC_T01#
OUT_CONVROTCOORD_T02# = LOC_T02#

OUT_CONVROTCOORD_T10# = LOC_T10#
OUT_CONVROTCOORD_T11# = LOC_T11#
OUT_CONVROTCOORD_T12# = LOC_T12#

OUT_CONVROTCOORD_T20# = LOC_T20#
OUT_CONVROTCOORD_T21# = LOC_T21#
OUT_CONVROTCOORD_T22# = LOC_T22#
Return'!RBINT_CONV_ROT_COORD_TO_MAT

*RBINT_CONV_ROT_MAT_TO_COORD'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_CONV_ROT_MAT_TO_COORD
' **********************************************************************

Dim LOC_IN_ATAN2FLG&(3)
Dim LOC_IN_ATAN2X#(3)
Dim LOC_IN_ATAN2Y#(3)
Dim LOC_OUT_ATAN2#(3)

OUT_CONVROTMAT_RET& = 0

OUT_CONVROTMAT_W# = 0
OUT_CONVROTMAT_P# = 0
OUT_CONVROTMAT_R# = 0

LOC_T00# = IN_CONVROTMAT_T00#
LOC_T01# = IN_CONVROTMAT_T01#
LOC_T02# = IN_CONVROTMAT_T02#

LOC_T10# = IN_CONVROTMAT_T10#
LOC_T11# = IN_CONVROTMAT_T11#
LOC_T12# = IN_CONVROTMAT_T12#

LOC_T20# = IN_CONVROTMAT_T20#
LOC_T21# = IN_CONVROTMAT_T21#
LOC_T22# = IN_CONVROTMAT_T22#

Select IN_CONVROTMAT_EULER&
Case DEF_ZYX&

  LOC_S# = LOC_T21# ^ 2 + LOC_T22# ^ 2

  LOC_BOUNDARY# = Val(Str2$(LOC_T20#, 0, 4, 0, 0))

  If LOC_BOUNDARY# = 1 Then

    LOC_IN_ATAN2FLG&(0) = 0
    LOC_A#         = 0

    LOC_IN_ATAN2FLG&(1) = 0
    LOC_B#         = -DEF_PI# / 2

    LOC_IN_ATAN2FLG&(2) = 1
    LOC_IN_ATAN2Y#(2)   = -LOC_T01#
    LOC_IN_ATAN2X#(2)   =  LOC_T11#

  Elseif LOC_BOUNDARY# = -1 Then

    LOC_IN_ATAN2FLG&(0) = 0
    LOC_A#         = 0

    LOC_IN_ATAN2FLG&(1) = 0
    LOC_B#         = DEF_PI# / 2

    LOC_IN_ATAN2FLG&(2) = 1
    LOC_IN_ATAN2Y#(2)   = -LOC_T01#
    LOC_IN_ATAN2X#(2)   =  LOC_T11#

  Else

    LOC_IN_ATAN2FLG&(0) = 1
    LOC_IN_ATAN2Y#(0)   = LOC_T21#
    LOC_IN_ATAN2X#(0)   = LOC_T22#

    LOC_IN_ATAN2FLG&(1) = 1
    LOC_IN_ATAN2Y#(1)   = -LOC_T20#
    LOC_IN_ATAN2X#(1)   = Sqr(LOC_S#)

    LOC_IN_ATAN2FLG&(2) = 1
    LOC_IN_ATAN2Y#(2)   = LOC_T10#
    LOC_IN_ATAN2X#(2)   = LOC_T00#

  EndIf

Case DEF_ZYZ&

  LOC_S#   = LOC_T02# ^ 2 + LOC_T12# ^ 2

  LOC_BOUNDARY# = Val(Str2$(LOC_T22#, 0, 4, 0, 0))

  If LOC_BOUNDARY# = 1 Then

    LOC_IN_ATAN2FLG&(0) = 0
    LOC_A#         = 0

    LOC_IN_ATAN2FLG&(1) = 0
    LOC_B#         = 0

    LOC_IN_ATAN2FLG&(2) = 1
    LOC_IN_ATAN2Y#(2)   = LOC_T10#
    LOC_IN_ATAN2X#(2)   = LOC_T00#

  Elseif LOC_BOUNDARY# = -1 Then

    LOC_IN_ATAN2FLG&(0) = 0
    LOC_A#         = 0

    LOC_IN_ATAN2FLG&(1) = 0
    LOC_B#         = DEF_PI#

    LOC_IN_ATAN2FLG&(2) = 1
    LOC_IN_ATAN2Y#(2)   =  LOC_T10#
    LOC_IN_ATAN2X#(2)   = -LOC_T00#

  Else

    LOC_IN_ATAN2FLG&(0) = 1
    LOC_IN_ATAN2Y#(0)   =  LOC_T12#
    LOC_IN_ATAN2X#(0)   =  LOC_T02#

    LOC_IN_ATAN2FLG&(1) = 1
    LOC_IN_ATAN2Y#(1)   =  Sqr(LOC_S#)
    LOC_IN_ATAN2X#(1)   =  LOC_T22#

    LOC_IN_ATAN2FLG&(2) = 1
    LOC_IN_ATAN2Y#(2)   =  LOC_T21#
    LOC_IN_ATAN2X#(2)   = -LOC_T20#

  EndIf

Case Else

End Select

For LOC_I& = 0 To 2

  If LOC_IN_ATAN2FLG&(LOC_I&) = 1 Then

    If LOC_IN_ATAN2X#(LOC_I&) > 0 Then

      LOC_OUT_ATAN2#(LOC_I&) = Atn(LOC_IN_ATAN2Y#(LOC_I&) / LOC_IN_ATAN2X#(LOC_I&))

    Elseif LOC_IN_ATAN2Y#(LOC_I&) >= 0 AND LOC_IN_ATAN2X#(LOC_I&) < 0 Then

      LOC_OUT_ATAN2#(LOC_I&) = Atn(LOC_IN_ATAN2Y#(LOC_I&) / LOC_IN_ATAN2X#(LOC_I&)) + DEF_PI#

    Elseif LOC_IN_ATAN2Y#(LOC_I&) < 0  AND LOC_IN_ATAN2X#(LOC_I&) < 0 Then

      LOC_OUT_ATAN2#(LOC_I&) = Atn(LOC_IN_ATAN2Y#(LOC_I&) / LOC_IN_ATAN2X#(LOC_I&)) - DEF_PI#

    Elseif LOC_IN_ATAN2Y#(LOC_I&) > 0  AND LOC_IN_ATAN2X#(LOC_I&) = 0 Then

      LOC_OUT_ATAN2#(LOC_I&) =  DEF_PI# / 2

    Elseif LOC_IN_ATAN2Y#(LOC_I&) < 0  AND LOC_IN_ATAN2X#(LOC_I&) = 0 Then

      LOC_OUT_ATAN2#(LOC_I&) = -DEF_PI# / 2

    Elseif LOC_IN_ATAN2Y#(LOC_I&) = 0  AND LOC_IN_ATAN2X#(LOC_I&) = 0 Then
      '--------------------
      '  Error
      '--------------------
      Print "ERROR : RBINT_CONV_ROT_MAT_TO_COORD : ", DEF_ERRMSG_INVALID$
      LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ + "ERROR : RBINT_CONV_ROT_MAT_TO_COORD : " +  DEF_ERRMSG_INVALID$ + DEF_ERRLOG_SPRT$

      OUT_CONVROTMAT_RET& = -1
      Return

    EndIf

    Select LOC_I&
    Case 0

      LOC_A# = LOC_OUT_ATAN2#(LOC_I&)

    Case 1

      LOC_B# = LOC_OUT_ATAN2#(LOC_I&)

    Case 2

      LOC_C# = LOC_OUT_ATAN2#(LOC_I&)

    End Select

  EndIf

Next

LOC_W# = LOC_A# * 180 / DEF_PI#
LOC_P# = LOC_B# * 180 / DEF_PI#
LOC_R# = LOC_C# * 180 / DEF_PI#

LOC_W# = Val(Str2$(LOC_W#, 0, 4, 0, 0))
LOC_P# = Val(Str2$(LOC_P#, 0, 4, 0, 0))
LOC_R# = Val(Str2$(LOC_R#, 0, 4, 0, 0))

  If LOC_W# = -180 Then

    LOC_W# = 180

  EndIf

  If LOC_P# = -180 Then

    LOC_P# = 180

  EndIf

  If LOC_R# = -180 Then

    LOC_R# = 180

  EndIf

OUT_CONVROTMAT_W# = LOC_W#
OUT_CONVROTMAT_P# = LOC_P#
OUT_CONVROTMAT_R# = LOC_R#
Return'!RBINT_CONV_ROT_MAT_TO_COORD

*RBINT_TRANS_COORD'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_TRANS_COORD
' **********************************************************************

Dim LOC_SRCMATR#(4, 4)
Dim LOC_SRCMATT#(4, 4)

Dim LOC_OPEMATR#(4, 4)
Dim LOC_OPEMATT#(4, 4)

Dim LOC_TMPMATA#(4, 4)
Dim LOC_TMPMATB#(4, 4)

Dim LOC_DSTMAT#(4, 4)

OUT_TRANSCOORD_RET& = 0

LOC_EULER&   = IN_TRANSCOORD_EULER&
LOC_COSYS&   = IN_TRANSCOORD_COSYS&

LOC_SRCPOSX# = IN_TRANSCOORD_SRCPOSX#
LOC_SRCPOSY# = IN_TRANSCOORD_SRCPOSY#
LOC_SRCPOSZ# = IN_TRANSCOORD_SRCPOSZ#

LOC_SRCPOSW# = IN_TRANSCOORD_SRCPOSW#
LOC_SRCPOSP# = IN_TRANSCOORD_SRCPOSP#
LOC_SRCPOSR# = IN_TRANSCOORD_SRCPOSR#

LOC_OPEPOSX# = IN_TRANSCOORD_OPEPOSX#
LOC_OPEPOSY# = IN_TRANSCOORD_OPEPOSY#
LOC_OPEPOSZ# = IN_TRANSCOORD_OPEPOSZ#

LOC_OPEPOSRX# = IN_TRANSCOORD_OPEPOSRX#
LOC_OPEPOSRY# = IN_TRANSCOORD_OPEPOSRY#
LOC_OPEPOSRZ# = IN_TRANSCOORD_OPEPOSRZ#

LOC_I& = 0
LOC_J& = 0
LOC_K& = 0

IN_CONVROTCOORD_EULER& = IN_TRANSCOORD_EULER&

IN_CONVROTCOORD_W# = LOC_SRCPOSW#
IN_CONVROTCOORD_P# = LOC_SRCPOSP#
IN_CONVROTCOORD_R# = LOC_SRCPOSR#

Gosub *RBINT_CONV_ROT_COORD_TO_MAT

If OUT_CONVROTCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_TRANS_COORD : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_TRANS_COORD : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_TRANSCOORD_RET& = -1

  Return

EndIf

LOC_SRCMATR#(0, 0) = OUT_CONVROTCOORD_T00#
LOC_SRCMATR#(0, 1) = OUT_CONVROTCOORD_T01#
LOC_SRCMATR#(0, 2) = OUT_CONVROTCOORD_T02#
LOC_SRCMATR#(0, 3) = 0

LOC_SRCMATR#(1, 0) = OUT_CONVROTCOORD_T10#
LOC_SRCMATR#(1, 1) = OUT_CONVROTCOORD_T11#
LOC_SRCMATR#(1, 2) = OUT_CONVROTCOORD_T12#
LOC_SRCMATR#(1, 3) = 0

LOC_SRCMATR#(2, 0) = OUT_CONVROTCOORD_T20#
LOC_SRCMATR#(2, 1) = OUT_CONVROTCOORD_T21#
LOC_SRCMATR#(2, 2) = OUT_CONVROTCOORD_T22#
LOC_SRCMATR#(2, 3) = 0

LOC_SRCMATR#(3, 0) = 0
LOC_SRCMATR#(3, 1) = 0
LOC_SRCMATR#(3, 2) = 0
LOC_SRCMATR#(3, 3) = 1

LOC_SRCMATT#(0, 0) = 1
LOC_SRCMATT#(0, 1) = 0
LOC_SRCMATT#(0, 2) = 0
LOC_SRCMATT#(0, 3) = LOC_SRCPOSX#

LOC_SRCMATT#(1, 0) = 0
LOC_SRCMATT#(1, 1) = 1
LOC_SRCMATT#(1, 2) = 0
LOC_SRCMATT#(1, 3) = LOC_SRCPOSY#

LOC_SRCMATT#(2, 0) = 0
LOC_SRCMATT#(2, 1) = 0
LOC_SRCMATT#(2, 2) = 1
LOC_SRCMATT#(2, 3) = LOC_SRCPOSZ#

LOC_SRCMATT#(3, 0) = 0
LOC_SRCMATT#(3, 1) = 0
LOC_SRCMATT#(3, 2) = 0
LOC_SRCMATT#(3, 3) = 1

IN_CONVROTCOORD_EULER& = DEF_ZYX&

IN_CONVROTCOORD_W# = LOC_OPEPOSRX#
IN_CONVROTCOORD_P# = LOC_OPEPOSRY#
IN_CONVROTCOORD_R# = LOC_OPEPOSRZ#

Gosub *RBINT_CONV_ROT_COORD_TO_MAT

If OUT_CONVROTCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_TRANS_COORD : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_TRANS_COORD : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_TRANSCOORD_RET& = -1

  Return

EndIf

LOC_OPEMATR#(0, 0) = OUT_CONVROTCOORD_T00#
LOC_OPEMATR#(0, 1) = OUT_CONVROTCOORD_T01#
LOC_OPEMATR#(0, 2) = OUT_CONVROTCOORD_T02#
LOC_OPEMATR#(0, 3) = 0

LOC_OPEMATR#(1, 0) = OUT_CONVROTCOORD_T10#
LOC_OPEMATR#(1, 1) = OUT_CONVROTCOORD_T11#
LOC_OPEMATR#(1, 2) = OUT_CONVROTCOORD_T12#
LOC_OPEMATR#(1, 3) = 0

LOC_OPEMATR#(2, 0) = OUT_CONVROTCOORD_T20#
LOC_OPEMATR#(2, 1) = OUT_CONVROTCOORD_T21#
LOC_OPEMATR#(2, 2) = OUT_CONVROTCOORD_T22#
LOC_OPEMATR#(2, 3) = 0

LOC_OPEMATR#(3, 0) = 0
LOC_OPEMATR#(3, 1) = 0
LOC_OPEMATR#(3, 2) = 0
LOC_OPEMATR#(3, 3) = 1

LOC_OPEMATT#(0, 0) = 1
LOC_OPEMATT#(0, 1) = 0
LOC_OPEMATT#(0, 2) = 0
LOC_OPEMATT#(0, 3) = LOC_OPEPOSX#

LOC_OPEMATT#(1, 0) = 0
LOC_OPEMATT#(1, 1) = 1
LOC_OPEMATT#(1, 2) = 0
LOC_OPEMATT#(1, 3) = LOC_OPEPOSY#

LOC_OPEMATT#(2, 0) = 0
LOC_OPEMATT#(2, 1) = 0
LOC_OPEMATT#(2, 2) = 1
LOC_OPEMATT#(2, 3) = LOC_OPEPOSZ#

LOC_OPEMATT#(3, 0) = 0
LOC_OPEMATT#(3, 1) = 0
LOC_OPEMATT#(3, 2) = 0
LOC_OPEMATT#(3, 3) = 1

Select IN_TRANSCOORD_COSYS&
Case DEF_WORLD&

  For LOC_I& = 0 To 3
    For LOC_J& = 0 To 3

      LOC_TMPMATA#(LOC_I&, LOC_J&) = 0

      For LOC_K& = 0 To 3

        LOC_TMPMATA#(LOC_I&, LOC_J&) = LOC_TMPMATA#(LOC_I&, LOC_J&) + LOC_OPEMATR#(LOC_I&, LOC_K&) * LOC_SRCMATR#(LOC_K&, LOC_J&)

      Next
    Next
  Next

  For LOC_I& = 0 To 3
    For LOC_J& = 0 To 3

      LOC_TMPMATB#(LOC_I&, LOC_J&) = 0

      For LOC_K& = 0 To 3

        LOC_TMPMATB#(LOC_I&, LOC_J&) = LOC_TMPMATB#(LOC_I&, LOC_J&) + LOC_OPEMATT#(LOC_I&, LOC_K&) * LOC_TMPMATA#(LOC_K&, LOC_J&)

      Next
    Next
  Next

  For LOC_I& = 0 To 3
    For LOC_J& = 0 To 3

      LOC_DSTMAT#(LOC_I&, LOC_J&) = 0

      For LOC_K& = 0 To 3

        LOC_DSTMAT#(LOC_I&, LOC_J&) = LOC_DSTMAT#(LOC_I&, LOC_J&) + LOC_SRCMATT#(LOC_I&, LOC_K&) * LOC_TMPMATB#(LOC_K&, LOC_J&)

      Next
    Next
  Next

Case DEF_TOOL&

  For LOC_I& = 0 To 3
    For LOC_J& = 0 To 3

      LOC_TMPMATA#(LOC_I&, LOC_J&) = 0

      For LOC_K& = 0 To 3

        LOC_TMPMATA#(LOC_I&, LOC_J&) = LOC_TMPMATA#(LOC_I&, LOC_J&) + LOC_OPEMATT#(LOC_I&, LOC_K&) * LOC_OPEMATR#(LOC_K&, LOC_J&)

      Next
    Next
  Next

  For LOC_I& = 0 To 3
    For LOC_J& = 0 To 3

      LOC_TMPMATB#(LOC_I&, LOC_J&) = 0

      For LOC_K& = 0 To 3

        LOC_TMPMATB#(LOC_I&, LOC_J&) = LOC_TMPMATB#(LOC_I&, LOC_J&) + LOC_SRCMATR#(LOC_I&, LOC_K&) * LOC_TMPMATA#(LOC_K&, LOC_J&)

      Next
    Next
  Next

  For LOC_I& = 0 To 3
    For LOC_J& = 0 To 3

      LOC_DSTMAT#(LOC_I&, LOC_J&) = 0

      For LOC_K& = 0 To 3

        LOC_DSTMAT#(LOC_I&, LOC_J&) = LOC_DSTMAT#(LOC_I&, LOC_J&) + LOC_SRCMATT#(LOC_I&, LOC_K&) * LOC_TMPMATB#(LOC_K&, LOC_J&)

      Next
    Next
  Next

End Select

IN_CONVROTMAT_EULER& = IN_TRANSCOORD_EULER&

IN_CONVROTMAT_T00# = LOC_DSTMAT#(0, 0)
IN_CONVROTMAT_T01# = LOC_DSTMAT#(0, 1)
IN_CONVROTMAT_T02# = LOC_DSTMAT#(0, 2)

IN_CONVROTMAT_T10# = LOC_DSTMAT#(1, 0)
IN_CONVROTMAT_T11# = LOC_DSTMAT#(1, 1)
IN_CONVROTMAT_T12# = LOC_DSTMAT#(1, 2)

IN_CONVROTMAT_T20# = LOC_DSTMAT#(2, 0)
IN_CONVROTMAT_T21# = LOC_DSTMAT#(2, 1)
IN_CONVROTMAT_T22# = LOC_DSTMAT#(2, 2)

Gosub *RBINT_CONV_ROT_MAT_TO_COORD

If OUT_CONVROTMAT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_TRANS_COORD : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_TRANS_COORD : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_TRANSCOORD_RET& = -1

  Return

EndIf

OUT_TRANSCOORD_DSTPOSX# = Val(Str2$(LOC_DSTMAT#(0, 3), 0, 4, 0, 0))
OUT_TRANSCOORD_DSTPOSY# = Val(Str2$(LOC_DSTMAT#(1, 3), 0, 4, 0, 0))
OUT_TRANSCOORD_DSTPOSZ# = Val(Str2$(LOC_DSTMAT#(2, 3), 0, 4, 0, 0))

OUT_TRANSCOORD_DSTPOSW# = Val(Str2$(OUT_CONVROTMAT_W#, 0, 4, 0, 0))
OUT_TRANSCOORD_DSTPOSP# = Val(Str2$(OUT_CONVROTMAT_P#, 0, 4, 0, 0))
OUT_TRANSCOORD_DSTPOSR# = Val(Str2$(OUT_CONVROTMAT_R#, 0, 4, 0, 0))
Return'!RBINT_TRANS_COORD

*RBINT_CALC_DST_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_CALC_DST_POS
' **********************************************************************

Dim LOC_A#(3, 3)
Dim LOC_B#(3, 3)
Dim LOC_C#(3, 3)
Dim LOC_D#(3, 3)
Dim LOC_INV#(3, 3)

OUT_CALCDSTPOS_RET& = 0

OUT_CALCDSTPOS_CALCPOSX# = 0
OUT_CALCDSTPOS_CALCPOSY# = 0
OUT_CALCDSTPOS_CALCPOSZ# = 0
OUT_CALCDSTPOS_CALCPOSW# = 0
OUT_CALCDSTPOS_CALCPOSP# = 0
OUT_CALCDSTPOS_CALCPOSR# = 0

LOC_SRCPOSX# = IN_CALCDSTPOS_SRCPOSX#
LOC_SRCPOSY# = IN_CALCDSTPOS_SRCPOSY#
LOC_SRCPOSZ# = IN_CALCDSTPOS_SRCPOSZ#
LOC_SRCPOSW# = IN_CALCDSTPOS_SRCPOSW#
LOC_SRCPOSP# = IN_CALCDSTPOS_SRCPOSP#
LOC_SRCPOSR# = IN_CALCDSTPOS_SRCPOSR#

LOC_DSTPOSX# = IN_CALCDSTPOS_DSTPOSX#
LOC_DSTPOSY# = IN_CALCDSTPOS_DSTPOSY#
LOC_DSTPOSZ# = IN_CALCDSTPOS_DSTPOSZ#
LOC_DSTPOSW# = IN_CALCDSTPOS_DSTPOSW#
LOC_DSTPOSP# = IN_CALCDSTPOS_DSTPOSP#
LOC_DSTPOSR# = IN_CALCDSTPOS_DSTPOSR#

LOC_CALCPOSX# = 0
LOC_CALCPOSY# = 0
LOC_CALCPOSZ# = 0
LOC_CALCPOSW# = 0
LOC_CALCPOSP# = 0
LOC_CALCPOSR# = 0

LOC_DISTANCE#  = 0

LOC_I& = 0
LOC_J& = 0
LOC_K& = 0

GetSystemData "Macro_SY", "RBVAR_ROT_DIST##", LOC_ROTDIST#
GetSystemData "Macro_SY", "RBVAR_TRANS_DIST##", LOC_TRANSDIST#

LOC_DISTANCE# = Sqr((LOC_SRCPOSX# - LOC_DSTPOSX#)^2 + (LOC_SRCPOSY# - LOC_DSTPOSY#)^2 + (LOC_SRCPOSZ# - LOC_DSTPOSZ#)^2)

If LOC_DISTANCE# > LOC_TRANSDIST# Then

  LOC_CALCPOSX# = LOC_SRCPOSX# + (LOC_DSTPOSX# - LOC_SRCPOSX#) * LOC_TRANSDIST# / LOC_DISTANCE#
  LOC_CALCPOSY# = LOC_SRCPOSY# + (LOC_DSTPOSY# - LOC_SRCPOSY#) * LOC_TRANSDIST# / LOC_DISTANCE#
  LOC_CALCPOSZ# = LOC_SRCPOSZ# + (LOC_DSTPOSZ# - LOC_SRCPOSZ#) * LOC_TRANSDIST# / LOC_DISTANCE#

Else

  LOC_CALCPOSX# = LOC_DSTPOSX#
  LOC_CALCPOSY# = LOC_DSTPOSY#
  LOC_CALCPOSZ# = LOC_DSTPOSZ#

EndIf

LOC_CALCPOSX# = Val(Str2$(LOC_CALCPOSX#, 0, 4, 0, 0))
LOC_CALCPOSY# = Val(Str2$(LOC_CALCPOSY#, 0, 4, 0, 0))
LOC_CALCPOSZ# = Val(Str2$(LOC_CALCPOSZ#, 0, 4, 0, 0))

IN_CONVROTCOORD_EULER& = IN_CALCDSTPOS_EULER&

IN_CONVROTCOORD_W# = LOC_SRCPOSW#
IN_CONVROTCOORD_P# = LOC_SRCPOSP#
IN_CONVROTCOORD_R# = LOC_SRCPOSR#

Gosub *RBINT_CONV_ROT_COORD_TO_MAT

If OUT_CONVROTCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_CALC_DST_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_CALC_DST_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_CALCDSTPOS_RET& = -1
  Return

EndIf

LOC_A#(0, 0) = OUT_CONVROTCOORD_T00#
LOC_A#(0, 1) = OUT_CONVROTCOORD_T01#
LOC_A#(0, 2) = OUT_CONVROTCOORD_T02#

LOC_A#(1, 0) = OUT_CONVROTCOORD_T10#
LOC_A#(1, 1) = OUT_CONVROTCOORD_T11#
LOC_A#(1, 2) = OUT_CONVROTCOORD_T12#

LOC_A#(2, 0) = OUT_CONVROTCOORD_T20#
LOC_A#(2, 1) = OUT_CONVROTCOORD_T21#
LOC_A#(2, 2) = OUT_CONVROTCOORD_T22#

IN_CONVROTCOORD_EULER& = IN_CALCDSTPOS_EULER&

IN_CONVROTCOORD_W# = LOC_DSTPOSW#
IN_CONVROTCOORD_P# = LOC_DSTPOSP#
IN_CONVROTCOORD_R# = LOC_DSTPOSR#

Gosub *RBINT_CONV_ROT_COORD_TO_MAT

If OUT_CONVROTCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_CALC_DST_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_CALC_DST_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_CALCDSTPOS_RET& = -1
  Return

EndIf

LOC_B#(0, 0) = OUT_CONVROTCOORD_T00#
LOC_B#(0, 1) = OUT_CONVROTCOORD_T01#
LOC_B#(0, 2) = OUT_CONVROTCOORD_T02#

LOC_B#(1, 0) = OUT_CONVROTCOORD_T10#
LOC_B#(1, 1) = OUT_CONVROTCOORD_T11#
LOC_B#(1, 2) = OUT_CONVROTCOORD_T12#

LOC_B#(2, 0) = OUT_CONVROTCOORD_T20#
LOC_B#(2, 1) = OUT_CONVROTCOORD_T21#
LOC_B#(2, 2) = OUT_CONVROTCOORD_T22#

LOC_DET# = 0

LOC_DET# = LOC_DET# + LOC_A#(0, 0) * LOC_A#(1, 1) * LOC_A#(2, 2)
LOC_DET# = LOC_DET# + LOC_A#(0, 1) * LOC_A#(1, 2) * LOC_A#(2, 0)
LOC_DET# = LOC_DET# + LOC_A#(0, 2) * LOC_A#(1, 0) * LOC_A#(2, 1)
LOC_DET# = LOC_DET# - LOC_A#(0, 2) * LOC_A#(1, 1) * LOC_A#(2, 0)
LOC_DET# = LOC_DET# - LOC_A#(0, 1) * LOC_A#(1, 0) * LOC_A#(2, 2)
LOC_DET# = LOC_DET# - LOC_A#(0, 0) * LOC_A#(1, 2) * LOC_A#(2, 1)

LOC_DET# = Val(Str2$(LOC_DET#, 0, 4, 0, 0))

If LOC_DET# = 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_CALC_DST_POS : ", DEF_ERRMSG_INVALID$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_CALC_DST_POS : " +  DEF_ERRMSG_INVALID$ + DEF_ERRLOG_SPRT$

  OUT_CALCDSTPOS_RET& = -1
  Return

EndIf

LOC_INV#(0, 0) =  1 / LOC_DET# * (LOC_A#(1, 1) *  LOC_A#(2, 2) -  LOC_A#(1, 2) * LOC_A#(2, 1))
LOC_INV#(0, 1) = -1 / LOC_DET# * (LOC_A#(0, 1) *  LOC_A#(2, 2) -  LOC_A#(0, 2) * LOC_A#(2, 1))
LOC_INV#(0, 2) =  1 / LOC_DET# * (LOC_A#(0, 1) *  LOC_A#(1, 2) -  LOC_A#(0, 2) * LOC_A#(1, 1))

LOC_INV#(1, 0) = -1 / LOC_DET# * (LOC_A#(1, 0) *  LOC_A#(2, 2) -  LOC_A#(1, 2) * LOC_A#(2, 0))
LOC_INV#(1, 1) =  1 / LOC_DET# * (LOC_A#(0, 0) *  LOC_A#(2, 2) -  LOC_A#(0, 2) * LOC_A#(2, 0))
LOC_INV#(1, 2) = -1 / LOC_DET# * (LOC_A#(0, 0) *  LOC_A#(1, 2) -  LOC_A#(0, 2) * LOC_A#(1, 0))

LOC_INV#(2, 0) =  1 / LOC_DET# * (LOC_A#(1, 0) *  LOC_A#(2, 1) -  LOC_A#(1, 1) * LOC_A#(2, 0))
LOC_INV#(2, 1) = -1 / LOC_DET# * (LOC_A#(0, 0) *  LOC_A#(2, 1) -  LOC_A#(0, 1) * LOC_A#(2, 0))
LOC_INV#(2, 2) =  1 / LOC_DET# * (LOC_A#(0, 0) *  LOC_A#(1, 1) -  LOC_A#(0, 1) * LOC_A#(1, 0))

For LOC_I& = 0 To 2
  For LOC_J& = 0 To 2

    LOC_C#(LOC_I&, LOC_J&) = 0

    For LOC_K& = 0 To 2

      LOC_C#(LOC_I&, LOC_J&) = LOC_C#(LOC_I&, LOC_J&) + LOC_B#(LOC_I&, LOC_K&) * LOC_INV#(LOC_K&, LOC_J&)

    Next
  Next
Next

IN_CONVROTMAT_EULER& = DEF_ZYX&

IN_CONVROTMAT_T00# = LOC_C#(0, 0)
IN_CONVROTMAT_T01# = LOC_C#(0, 1)
IN_CONVROTMAT_T02# = LOC_C#(0, 2)

IN_CONVROTMAT_T10# = LOC_C#(1, 0)
IN_CONVROTMAT_T11# = LOC_C#(1, 1)
IN_CONVROTMAT_T12# = LOC_C#(1, 2)

IN_CONVROTMAT_T20# = LOC_C#(2, 0)
IN_CONVROTMAT_T21# = LOC_C#(2, 1)
IN_CONVROTMAT_T22# = LOC_C#(2, 2)

Gosub *RBINT_CONV_ROT_MAT_TO_COORD

If OUT_CONVROTMAT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_CALC_DST_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_CALC_DST_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_CALCDSTPOS_RET& = -1
  Return

EndIf

LOC_OPEPOSW# = OUT_CONVROTMAT_W#
LOC_OPEPOSP# = OUT_CONVROTMAT_P#
LOC_OPEPOSR# = OUT_CONVROTMAT_R#

LOC_ABSPOSW# = Abs(LOC_OPEPOSW#)
LOC_ABSPOSP# = Abs(LOC_OPEPOSP#)
LOC_ABSPOSR# = Abs(LOC_OPEPOSR#)

If LOC_ABSPOSW# > LOC_ROTDIST# Then

  If LOC_OPEPOSW# >= 0 Then

     LOC_SIGN# =  1

  Else

     LOC_SIGN# = -1

  EndIf

  LOC_OPEPOSW# = LOC_ROTDIST# * LOC_SIGN#
EndIf

If LOC_ABSPOSP# > LOC_ROTDIST# Then

  If LOC_OPEPOSP# >= 0 Then

     LOC_SIGN# =  1

  Else

     LOC_SIGN# = -1

  EndIf

  LOC_OPEPOSP# = LOC_ROTDIST# * LOC_SIGN#
EndIf

If LOC_ABSPOSR# > LOC_ROTDIST# Then

  If LOC_OPEPOSR# >= 0 Then

     LOC_SIGN# =  1

  Else

     LOC_SIGN# = -1

  EndIf

  LOC_OPEPOSR# = LOC_ROTDIST# * LOC_SIGN#

EndIf

IN_CONVROTCOORD_EULER& = DEF_ZYX&

IN_CONVROTCOORD_W# = LOC_OPEPOSW#
IN_CONVROTCOORD_P# = LOC_OPEPOSP#
IN_CONVROTCOORD_R# = LOC_OPEPOSR#

Gosub *RBINT_CONV_ROT_COORD_TO_MAT

If OUT_CONVROTCOORD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_CALC_DST_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_CALC_DST_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_CALCDSTPOS_RET& = -1
  Return

EndIf

LOC_C#(0, 0) = OUT_CONVROTCOORD_T00#
LOC_C#(0, 1) = OUT_CONVROTCOORD_T01#
LOC_C#(0, 2) = OUT_CONVROTCOORD_T02#

LOC_C#(1, 0) = OUT_CONVROTCOORD_T10#
LOC_C#(1, 1) = OUT_CONVROTCOORD_T11#
LOC_C#(1, 2) = OUT_CONVROTCOORD_T12#

LOC_C#(2, 0) = OUT_CONVROTCOORD_T20#
LOC_C#(2, 1) = OUT_CONVROTCOORD_T21#
LOC_C#(2, 2) = OUT_CONVROTCOORD_T22#

For LOC_I& = 0 To 2
  For LOC_J& = 0 To 2

    LOC_D#(LOC_I&, LOC_J&) = 0

    For LOC_K& = 0 To 2

      LOC_D#(LOC_I&, LOC_J&) = LOC_D#(LOC_I&, LOC_J&) + LOC_C#(LOC_I&, LOC_K&) * LOC_A#(LOC_K&, LOC_J&)

    Next
  Next
Next

IN_CONVROTMAT_EULER& = IN_CALCDSTPOS_EULER&

IN_CONVROTMAT_T00# = LOC_D#(0, 0)
IN_CONVROTMAT_T01# = LOC_D#(0, 1)
IN_CONVROTMAT_T02# = LOC_D#(0, 2)

IN_CONVROTMAT_T10# = LOC_D#(1, 0)
IN_CONVROTMAT_T11# = LOC_D#(1, 1)
IN_CONVROTMAT_T12# = LOC_D#(1, 2)

IN_CONVROTMAT_T20# = LOC_D#(2, 0)
IN_CONVROTMAT_T21# = LOC_D#(2, 1)
IN_CONVROTMAT_T22# = LOC_D#(2, 2)

Gosub *RBINT_CONV_ROT_MAT_TO_COORD

If OUT_CONVROTMAT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_CALC_DST_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_CALC_DST_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_CALCDSTPOS_RET& = -1
  Return

EndIf

LOC_CALCPOSW# = OUT_CONVROTMAT_W#
LOC_CALCPOSP# = OUT_CONVROTMAT_P#
LOC_CALCPOSR# = OUT_CONVROTMAT_R#

OUT_CALCDSTPOS_CALCPOSX# = LOC_CALCPOSX#
OUT_CALCDSTPOS_CALCPOSY# = LOC_CALCPOSY#
OUT_CALCDSTPOS_CALCPOSZ# = LOC_CALCPOSZ#
OUT_CALCDSTPOS_CALCPOSW# = LOC_CALCPOSW#
OUT_CALCDSTPOS_CALCPOSP# = LOC_CALCPOSP#
OUT_CALCDSTPOS_CALCPOSR# = LOC_CALCPOSR#
Return'!RBINT_CALC_DST_POS

*RBINT_GET_VER_INF'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_GET_VER_INF
' **********************************************************************

OUT_GETVERINF_RET&    = 0
OUT_GETVERINF_PRGVER$ = ""

LOC_TIMEOUT&   = 0

GetSystemData "Macro_SY", "RBVAR_COM_TOUT&&", LOC_TIMEOUT&

IN_EXECCMD_CMDID&    = DEF_GETVERINF&
IN_EXECCMD_TIMEOUT&  = LOC_TIMEOUT&

Gosub *RBINT_EXEC_COMMAND

If OUT_EXECCMD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_GET_VER_INF : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_GET_VER_INF : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_GETVERINF_RET& = -1
  Return

EndIf

OUT_GETVERINF_PRGVER$ = OUT_EXECCMD_PRGVER$
Return'!RBINT_GET_VER_INF

*RBINT_GET_CUR_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_GET_CUR_POS
' **********************************************************************

OUT_GETCURPOS_RET&     = 0

OUT_GETCURPOS_CURPOSX# = 0
OUT_GETCURPOS_CURPOSY# = 0
OUT_GETCURPOS_CURPOSZ# = 0
OUT_GETCURPOS_CURPOSW# = 0
OUT_GETCURPOS_CURPOSP# = 0
OUT_GETCURPOS_CURPOSR# = 0

LOC_COORD&     = 0
LOC_TIMEOUT&   = 0

GetSystemData "Macro_SY", "RBVAR_COM_TOUT&&", LOC_TIMEOUT&

IN_EXECCMD_CMDID&    = DEF_GETCURPOS&
IN_EXECCMD_TIMEOUT&  = LOC_TIMEOUT&

Gosub *RBINT_EXEC_COMMAND

If OUT_EXECCMD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_GET_CUR_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_GET_CUR_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_GETCURPOS_RET& = -1
  Return

EndIf

OUT_GETCURPOS_CURPOSX# = OUT_EXECCMD_CURPOSX#
OUT_GETCURPOS_CURPOSY# = OUT_EXECCMD_CURPOSY#
OUT_GETCURPOS_CURPOSZ# = OUT_EXECCMD_CURPOSZ#
OUT_GETCURPOS_CURPOSW# = OUT_EXECCMD_CURPOSW#
OUT_GETCURPOS_CURPOSP# = OUT_EXECCMD_CURPOSP#
OUT_GETCURPOS_CURPOSR# = OUT_EXECCMD_CURPOSR#
Return'!RBINT_GET_CUR_POS

*RBINT_MOVE_ROBOT'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_MOVE_ROBOT
' **********************************************************************

OUT_MOVE_RET&  = 0

OUT_MOVE_CURPOSX#  = 0
OUT_MOVE_CURPOSY#  = 0
OUT_MOVE_CURPOSZ#  = 0
OUT_MOVE_CURPOSW#  = 0
OUT_MOVE_CURPOSP#  = 0
OUT_MOVE_CURPOSR#  = 0

LOC_TIMEOUT&   = 0
LOC_SPEED&     = 0
LOC_DISTXYZ#   = 0

LOC_CURPOSX#   = 0
LOC_CURPOSY#   = 0
LOC_CURPOSZ#   = 0
LOC_CURPOSRX#  = 0
LOC_CURPOSRY#  = 0
LOC_CURPOSRZ#  = 0

LOC_CMDPOSX#   = 0
LOC_CMDPOSY#   = 0
LOC_CMDPOSZ#   = 0
LOC_CMDPOSRX#  = 0
LOC_CMDPOSRY#  = 0
LOC_CMDPOSRZ#  = 0

GetSystemData "Macro_SY", "RBVAR_COM_TOUT&&", LOC_TIMEOUT&
GetSystemData "Macro_SY", "RBVAR_SPD&&", LOC_SPEED&

IN_EXECCMD_CMDID&    = DEF_SETPARAM&
IN_EXECCMD_TIMEOUT&  = LOC_TIMEOUT&
IN_EXECCMD_SPEED&    = LOC_SPEED&

Gosub *RBINT_EXEC_COMMAND

If OUT_EXECCMD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_MOVE_ROBOT : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_MOVE_ROBOT : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_MOVE_RET& = -1
  Return

EndIf

IN_EXECCMD_CMDID&    = DEF_ABSMOVE&
IN_EXECCMD_TIMEOUT&  = LOC_TIMEOUT&

IN_EXECCMD_CMDPOSX# = IN_MOVE_CMDPOSX#
IN_EXECCMD_CMDPOSY# = IN_MOVE_CMDPOSY#
IN_EXECCMD_CMDPOSZ# = IN_MOVE_CMDPOSZ#
IN_EXECCMD_CMDPOSW# = IN_MOVE_CMDPOSW#
IN_EXECCMD_CMDPOSP# = IN_MOVE_CMDPOSP#
IN_EXECCMD_CMDPOSR# = IN_MOVE_CMDPOSR#

Gosub *RBINT_EXEC_COMMAND

If OUT_EXECCMD_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_MOVE_ROBOT : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_MOVE_ROBOT : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_MOVE_RET& = -1
  Return

EndIf

OUT_MOVE_CURPOSX# = OUT_EXECCMD_CURPOSX#
OUT_MOVE_CURPOSY# = OUT_EXECCMD_CURPOSY#
OUT_MOVE_CURPOSZ# = OUT_EXECCMD_CURPOSZ#
OUT_MOVE_CURPOSW# = OUT_EXECCMD_CURPOSW#
OUT_MOVE_CURPOSP# = OUT_EXECCMD_CURPOSP#
OUT_MOVE_CURPOSR# = OUT_EXECCMD_CURPOSR#
Return'!RBINT_MOVE_ROBOT

*RBINT_EXEC_AUTO_CALIB_STEP'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBINT_EXEC_AUTO_CALIB_STEP
' **********************************************************************

OUT_EXECCALIB_RET&     = 0

OUT_EXECCALIB_CURPOSX# = 0
OUT_EXECCALIB_CURPOSY# = 0
OUT_EXECCALIB_CURPOSZ# = 0
OUT_EXECCALIB_CURPOSW# = 0
OUT_EXECCALIB_CURPOSP# = 0
OUT_EXECCALIB_CURPOSR# = 0

OUT_EXECCALIB_CALJDG&    = 0
OUT_EXECCALIB_CALENDFLG& = 0

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX#  = 0
LOC_CMDPOSY#  = 0
LOC_CMDPOSZ#  = 0
LOC_CMDPOSW#  = 0
LOC_CMDPOSP#  = 0
LOC_CMDPOSR#  = 0

LOC_CALJDG&    = 0
LOC_CALENDFLG& = 0

LOC_CALNXTPOSX# = 0
LOC_CALNXTPOSY# = 0
LOC_CALNXTPOSZ# = 0
LOC_CALNXTPOSW# = 0
LOC_CALNXTPOSP# = 0
LOC_CALNXTPOSR# = 0

MeasureStart

Try

  Measure 2

Catch
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_EXEC_AUTO_CALIB_STEP : ", DEF_ERRMSG_MEASURE$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_EXEC_AUTO_CALIB_STEP : " +  DEF_ERRMSG_MEASURE$ + DEF_ERRLOG_SPRT$

  OUT_EXECCALIB_RET& = -1

  MeasureStop
  Return

End Try

MeasureStop

GetSceneData "RBVAR_CAL_JDG&", LOC_CALJDG&
GetSceneData "RBVAR_CAL_END_FLG&", LOC_CALENDFLG& 

If LOC_CALJDG& <> 1 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_EXEC_AUTO_CALIB_STEP : ", DEF_ERRMSG_JUDGE$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_EXEC_AUTO_CALIB_STEP : " +  DEF_ERRMSG_JUDGE$ + DEF_ERRLOG_SPRT$

  OUT_EXECCALIB_RET& = -1
  Return

EndIf

GetSceneData "RBVAR_CAL_NXT_POS_X#", LOC_CALNXTPOSX#
GetSceneData "RBVAR_CAL_NXT_POS_Y#", LOC_CALNXTPOSY#
GetSceneData "RBVAR_CAL_NXT_POS_Z#", LOC_CALNXTPOSZ#
GetSceneData "RBVAR_CAL_NXT_POS_W#", LOC_CALNXTPOSW#
GetSceneData "RBVAR_CAL_NXT_POS_P#", LOC_CALNXTPOSP#
GetSceneData "RBVAR_CAL_NXT_POS_R#", LOC_CALNXTPOSR#

LOC_CMDPOSX# = LOC_CALNXTPOSX#
LOC_CMDPOSY# = LOC_CALNXTPOSY#
LOC_CMDPOSZ# = LOC_CALNXTPOSZ#
LOC_CMDPOSW# = LOC_CALNXTPOSW#
LOC_CMDPOSP# = LOC_CALNXTPOSP#
LOC_CMDPOSR# = LOC_CALNXTPOSR#

IN_MOVE_CMDPOSX# = LOC_CMDPOSX# 
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#
IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBINT_EXEC_AUTO_CALIB_STEP : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBINT_EXEC_AUTO_CALIB_STEP : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  OUT_EXECCALIB_RET& = -1
  Return

EndIf

OUT_EXECCALIB_CURPOSX# = OUT_MOVE_CURPOSX#
OUT_EXECCALIB_CURPOSY# = OUT_MOVE_CURPOSY#
OUT_EXECCALIB_CURPOSZ# = OUT_MOVE_CURPOSZ#
OUT_EXECCALIB_CURPOSW# = OUT_MOVE_CURPOSW#
OUT_EXECCALIB_CURPOSP# = OUT_MOVE_CURPOSP#
OUT_EXECCALIB_CURPOSR# = OUT_MOVE_CURPOSR#

OUT_EXECCALIB_CALJDG&    = LOC_CALJDG&
OUT_EXECCALIB_CALENDFLG& = LOC_CALENDFLG&
Return'!RBINT_EXEC_AUTO_CALIB_STEP

*RBEXT_MOVE_STD_APPRO_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_STD_APPRO_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_STD_APPRO_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_STD_APPRO_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

LOC_APPRODIST# = 0

LOC_TYPE&    = 0

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_STD_APPRO_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_STD_APPRO_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

GetSceneData "RBVAR_STD_GRP_POS_X##", LOC_CMDPOSX#
GetSceneData "RBVAR_STD_GRP_POS_Y##", LOC_CMDPOSY#
GetSceneData "RBVAR_STD_GRP_POS_Z##", LOC_CMDPOSZ#
GetSceneData "RBVAR_STD_GRP_POS_W##", LOC_CMDPOSW#
GetSceneData "RBVAR_STD_GRP_POS_P##", LOC_CMDPOSP#
GetSceneData "RBVAR_STD_GRP_POS_R##", LOC_CMDPOSR#

GetSceneData "RBVAR_STD_APPRO_DIST##", LOC_APPRODIST#

LOC_CMDPOSZ# = LOC_CMDPOSZ# + LOC_APPRODIST#

GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#

Select LOC_TYPE&
Case 1
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case 2
  IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
  IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case Else
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CURPOSR#

End Select

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_STD_APPRO_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_STD_APPRO_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_STD_APPRO_POS

*RBEXT_MOVE_RES_APPRO_POS'!
' **********************************************************************
'              (C) Copyright OMRON CORPORATION 2018               
'                      All Rights Reserved             
' **********************************************************************
' Function name    : RBEXT_MOVE_RES_APPRO_POS
' **********************************************************************

Gosub *RBINT_INIT

If OUT_INIT_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_RES_APPRO_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_RES_APPRO_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = 0
LOC_CURPOSY# = 0
LOC_CURPOSZ# = 0
LOC_CURPOSW# = 0
LOC_CURPOSP# = 0
LOC_CURPOSR# = 0

LOC_CMDPOSX# = 0
LOC_CMDPOSY# = 0
LOC_CMDPOSZ# = 0
LOC_CMDPOSW# = 0
LOC_CMDPOSP# = 0
LOC_CMDPOSR# = 0

LOC_APPRODIST# = 0

LOC_TYPE&    = 0

Gosub *RBINT_GET_CUR_POS

If OUT_GETCURPOS_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_RES_APPRO_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_RES_APPRO_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_GETCURPOS_CURPOSX#
LOC_CURPOSY# = OUT_GETCURPOS_CURPOSY#
LOC_CURPOSZ# = OUT_GETCURPOS_CURPOSZ#
LOC_CURPOSW# = OUT_GETCURPOS_CURPOSW#
LOC_CURPOSP# = OUT_GETCURPOS_CURPOSP#
LOC_CURPOSR# = OUT_GETCURPOS_CURPOSR#

GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_X#", LOC_CMDPOSX#
GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_Y#", LOC_CMDPOSY#
GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_Z#", LOC_CMDPOSZ#
GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_W#", LOC_CMDPOSW#
GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_P#", LOC_CMDPOSP#
GetSystemData "Macro_SY", "RBVAR_RES_CMD_POS_R#", LOC_CMDPOSR#

GetSceneData "RBVAR_STD_APPRO_DIST##", LOC_APPRODIST#

LOC_CMDPOSZ# = LOC_CMDPOSZ# + LOC_APPRODIST#

GetSystemData "Macro_SY", "RBVAR_TYPE&&", LOC_TYPE&

IN_MOVE_CMDPOSX# = LOC_CMDPOSX#
IN_MOVE_CMDPOSY# = LOC_CMDPOSY#
IN_MOVE_CMDPOSZ# = LOC_CMDPOSZ#

Select LOC_TYPE&
Case 1
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case 2
  IN_MOVE_CMDPOSW# = LOC_CMDPOSW#
  IN_MOVE_CMDPOSP# = LOC_CMDPOSP#
  IN_MOVE_CMDPOSR# = LOC_CMDPOSR#

Case Else
  IN_MOVE_CMDPOSW# = LOC_CURPOSW#
  IN_MOVE_CMDPOSP# = LOC_CURPOSP#
  IN_MOVE_CMDPOSR# = LOC_CURPOSR#

End Select

Gosub *RBINT_MOVE_ROBOT

If OUT_MOVE_RET& <> 0 Then
  '--------------------
  '  Error
  '--------------------
  Print "ERROR : RBEXT_MOVE_RES_APPRO_POS : ", DEF_ERRMSG_PROCFAILED$
  LOC_ERRLOG_MSG$ = LOC_ERRLOG_MSG$ +  "ERROR : RBEXT_MOVE_RES_APPRO_POS : " +  DEF_ERRMSG_PROCFAILED$ + DEF_ERRLOG_SPRT$

  Gosub *RBINT_FINAL
  Return

EndIf

LOC_CURPOSX# = OUT_MOVE_CURPOSX#
LOC_CURPOSY# = OUT_MOVE_CURPOSY#
LOC_CURPOSZ# = OUT_MOVE_CURPOSZ#
LOC_CURPOSW# = OUT_MOVE_CURPOSW#
LOC_CURPOSP# = OUT_MOVE_CURPOSP#
LOC_CURPOSR# = OUT_MOVE_CURPOSR#

SetSystemData "Macro_SY", "RBVAR_CUR_POS_X#", LOC_CURPOSX#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Y#", LOC_CURPOSY#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_Z#", LOC_CURPOSZ#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_W#", LOC_CURPOSW#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_P#", LOC_CURPOSP#
SetSystemData "Macro_SY", "RBVAR_CUR_POS_R#", LOC_CURPOSR#

Gosub *RBINT_FINAL
Return'!RBEXT_MOVE_RES_APPRO_POS

*FUNC_0037'!

Return'!FUNC_0037

*FUNC_0038'!

Return'!FUNC_0038

*FUNC_0039'!

Return'!FUNC_0039

*FUNC_0040'!

Return'!FUNC_0040

*FUNC_0041'!

Return'!FUNC_0041

*FUNC_0042'!

Return'!FUNC_0042

*FUNC_0043'!

Return'!FUNC_0043

*FUNC_0044'!

Return'!FUNC_0044

*FUNC_0045'!
Return'!FUNC_0045

*FUNC_0046'!
Return'!FUNC_0046

*FUNC_0047'!
Return'!FUNC_0047

*FUNC_0048'!
Return'!FUNC_0048

*FUNC_0049'!
Return'!FUNC_0049

*FUNC_0050'!
Return'!FUNC_0050

*FUNC_0051'!
Return'!FUNC_0051

*FUNC_0052'!
Return'!FUNC_0052

*FUNC_0053'!
Return'!FUNC_0053

*FUNC_0054'!
Return'!FUNC_0054

*FUNC_0055'!
Return'!FUNC_0055

*FUNC_0056'!
Return'!FUNC_0056

*FUNC_0057'!
Return'!FUNC_0057

*FUNC_0058'!
Return'!FUNC_0058

*FUNC_0059'!
Return'!FUNC_0059

*FUNC_0060'!
Return'!FUNC_0060

*FUNC_0061'!
Return'!FUNC_0061

*FUNC_0062'!
Return'!FUNC_0062

*FUNC_0063'!
Return'!FUNC_0063

*FUNC_0064'!
Return'!FUNC_0064

*FUNC_0065'!
Return'!FUNC_0065

*FUNC_0066'!
Return'!FUNC_0066

*FUNC_0067'!
Return'!FUNC_0067

*FUNC_0068'!
Return'!FUNC_0068

*FUNC_0069'!
Return'!FUNC_0069

*FUNC_0070'!
Return'!FUNC_0070

*FUNC_0071'!
Return'!FUNC_0071

*FUNC_0072'!
Return'!FUNC_0072

*FUNC_0073'!
Return'!FUNC_0073

*FUNC_0074'!
Return'!FUNC_0074

*FUNC_0075'!
Return'!FUNC_0075

*FUNC_0076'!
Return'!FUNC_0076

*FUNC_0077'!
Return'!FUNC_0077

*FUNC_0078'!
Return'!FUNC_0078

*FUNC_0079'!
Return'!FUNC_0079

*FUNC_0080'!
Return'!FUNC_0080

*FUNC_0081'!
Return'!FUNC_0081

*FUNC_0082'!
Return'!FUNC_0082

*FUNC_0083'!
Return'!FUNC_0083

*FUNC_0084'!
Return'!FUNC_0084

*FUNC_0085'!
Return'!FUNC_0085

*FUNC_0086'!
Return'!FUNC_0086

*FUNC_0087'!
Return'!FUNC_0087

*FUNC_0088'!
Return'!FUNC_0088

*FUNC_0089'!
Return'!FUNC_0089

*FUNC_0090'!
Return'!FUNC_0090

*FUNC_0091'!
Return'!FUNC_0091

*FUNC_0092'!
Return'!FUNC_0092

*FUNC_0093'!
Return'!FUNC_0093

*FUNC_0094'!
Return'!FUNC_0094

*FUNC_0095'!
Return'!FUNC_0095

*FUNC_0096'!
Return'!FUNC_0096

*FUNC_0097'!
Return'!FUNC_0097

*FUNC_0098'!
Return'!FUNC_0098

*FUNC_0099'!
Return'!FUNC_0099

*FUNC_0100'!
Return'!FUNC_0100

*FUNC_0101'!
Return'!FUNC_0101

*FUNC_0102'!
Return'!FUNC_0102

*FUNC_0103'!
Return'!FUNC_0103

*FUNC_0104'!
Return'!FUNC_0104

*FUNC_0105'!
Return'!FUNC_0105

*FUNC_0106'!
Return'!FUNC_0106

*FUNC_0107'!
Return'!FUNC_0107

*FUNC_0108'!
Return'!FUNC_0108

*FUNC_0109'!
Return'!FUNC_0109

*FUNC_0110'!
Return'!FUNC_0110

*FUNC_0111'!
Return'!FUNC_0111

*FUNC_0112'!
Return'!FUNC_0112

*FUNC_0113'!
Return'!FUNC_0113

*FUNC_0114'!
Return'!FUNC_0114

*FUNC_0115'!
Return'!FUNC_0115

*FUNC_0116'!
Return'!FUNC_0116

*FUNC_0117'!
Return'!FUNC_0117

*FUNC_0118'!
Return'!FUNC_0118

*FUNC_0119'!
Return'!FUNC_0119

*FUNC_0120'!
Return'!FUNC_0120

*FUNC_0121'!
Return'!FUNC_0121

*FUNC_0122'!
Return'!FUNC_0122

*FUNC_0123'!
Return'!FUNC_0123

*FUNC_0124'!
Return'!FUNC_0124

*FUNC_0125'!
Return'!FUNC_0125

*FUNC_0126'!
Return'!FUNC_0126

*FUNC_0127'!
Return'!FUNC_0127

*FUNC_0128'!
Return'!FUNC_0128

*FUNC_0129'!
Return'!FUNC_0129

*FUNC_0130'!
Return'!FUNC_0130

*FUNC_0131'!
Return'!FUNC_0131

*FUNC_0132'!
Return'!FUNC_0132

*FUNC_0133'!
Return'!FUNC_0133

*FUNC_0134'!
Return'!FUNC_0134

*FUNC_0135'!
Return'!FUNC_0135

*FUNC_0136'!
Return'!FUNC_0136

*FUNC_0137'!
Return'!FUNC_0137

*FUNC_0138'!
Return'!FUNC_0138

*FUNC_0139'!
Return'!FUNC_0139

*FUNC_0140'!
Return'!FUNC_0140

*FUNC_0141'!
Return'!FUNC_0141

*FUNC_0142'!
Return'!FUNC_0142

*FUNC_0143'!
Return'!FUNC_0143

*FUNC_0144'!
Return'!FUNC_0144

*FUNC_0145'!
Return'!FUNC_0145

*FUNC_0146'!
Return'!FUNC_0146

*FUNC_0147'!
Return'!FUNC_0147

*FUNC_0148'!
Return'!FUNC_0148

*FUNC_0149'!
Return'!FUNC_0149

*FUNC_0150'!
Return'!FUNC_0150

*FUNC_0151'!
Return'!FUNC_0151

*FUNC_0152'!
Return'!FUNC_0152

*FUNC_0153'!
Return'!FUNC_0153

*FUNC_0154'!
Return'!FUNC_0154

*FUNC_0155'!
Return'!FUNC_0155

*FUNC_0156'!
Return'!FUNC_0156

*FUNC_0157'!
Return'!FUNC_0157

*FUNC_0158'!
Return'!FUNC_0158

*FUNC_0159'!
Return'!FUNC_0159

*FUNC_0160'!
Return'!FUNC_0160

*FUNC_0161'!
Return'!FUNC_0161

*FUNC_0162'!
Return'!FUNC_0162

*FUNC_0163'!
Return'!FUNC_0163

*FUNC_0164'!
Return'!FUNC_0164

*FUNC_0165'!
Return'!FUNC_0165

*FUNC_0166'!
Return'!FUNC_0166

*FUNC_0167'!
Return'!FUNC_0167

*FUNC_0168'!
Return'!FUNC_0168

*FUNC_0169'!
Return'!FUNC_0169

*FUNC_0170'!
Return'!FUNC_0170

*FUNC_0171'!
Return'!FUNC_0171

*FUNC_0172'!
Return'!FUNC_0172

*FUNC_0173'!
Return'!FUNC_0173

*FUNC_0174'!
Return'!FUNC_0174

*FUNC_0175'!
Return'!FUNC_0175

*FUNC_0176'!
Return'!FUNC_0176

*FUNC_0177'!
Return'!FUNC_0177

*FUNC_0178'!
Return'!FUNC_0178

*FUNC_0179'!
Return'!FUNC_0179

*FUNC_0180'!
Return'!FUNC_0180

*FUNC_0181'!
Return'!FUNC_0181

*FUNC_0182'!
Return'!FUNC_0182

*FUNC_0183'!
Return'!FUNC_0183

*FUNC_0184'!
Return'!FUNC_0184

*FUNC_0185'!
Return'!FUNC_0185

*FUNC_0186'!
Return'!FUNC_0186

*FUNC_0187'!
Return'!FUNC_0187

*FUNC_0188'!
Return'!FUNC_0188

*FUNC_0189'!
Return'!FUNC_0189

*FUNC_0190'!
Return'!FUNC_0190

*FUNC_0191'!
Return'!FUNC_0191

*FUNC_0192'!
Return'!FUNC_0192

*FUNC_0193'!
Return'!FUNC_0193

*FUNC_0194'!
Return'!FUNC_0194

*FUNC_0195'!
Return'!FUNC_0195

*FUNC_0196'!
Return'!FUNC_0196

*FUNC_0197'!
Return'!FUNC_0197

*FUNC_0198'!
Return'!FUNC_0198

*FUNC_0199'!
Return'!FUNC_0199

*FUNC_0200'!
Return'!FUNC_0200

*FUNC_0201'!
Return'!FUNC_0201

*FUNC_0202'!
Return'!FUNC_0202

*FUNC_0203'!
Return'!FUNC_0203

*FUNC_0204'!
Return'!FUNC_0204

*FUNC_0205'!
Return'!FUNC_0205

*FUNC_0206'!
Return'!FUNC_0206

*FUNC_0207'!
Return'!FUNC_0207

*FUNC_0208'!
Return'!FUNC_0208

*FUNC_0209'!
Return'!FUNC_0209

*FUNC_0210'!
Return'!FUNC_0210

*FUNC_0211'!
Return'!FUNC_0211

*FUNC_0212'!
Return'!FUNC_0212

*FUNC_0213'!
Return'!FUNC_0213

*FUNC_0214'!
Return'!FUNC_0214

*FUNC_0215'!
Return'!FUNC_0215

*FUNC_0216'!
Return'!FUNC_0216

*FUNC_0217'!
Return'!FUNC_0217

*FUNC_0218'!
Return'!FUNC_0218

*FUNC_0219'!
Return'!FUNC_0219

*FUNC_0220'!
Return'!FUNC_0220

*FUNC_0221'!
Return'!FUNC_0221

*FUNC_0222'!
Return'!FUNC_0222

*FUNC_0223'!
Return'!FUNC_0223

*FUNC_0224'!
Return'!FUNC_0224

*FUNC_0225'!
Return'!FUNC_0225

*FUNC_0226'!
Return'!FUNC_0226

*FUNC_0227'!
Return'!FUNC_0227

*FUNC_0228'!
Return'!FUNC_0228

*FUNC_0229'!
Return'!FUNC_0229

*FUNC_0230'!
Return'!FUNC_0230

*FUNC_0231'!
Return'!FUNC_0231

*FUNC_0232'!
Return'!FUNC_0232

*FUNC_0233'!
Return'!FUNC_0233

*FUNC_0234'!
Return'!FUNC_0234

*FUNC_0235'!
Return'!FUNC_0235

*FUNC_0236'!
Return'!FUNC_0236

*FUNC_0237'!
Return'!FUNC_0237

*FUNC_0238'!
Return'!FUNC_0238

*FUNC_0239'!
Return'!FUNC_0239

*FUNC_0240'!
Return'!FUNC_0240

*FUNC_0241'!
Return'!FUNC_0241

*FUNC_0242'!
Return'!FUNC_0242

*FUNC_0243'!
Return'!FUNC_0243

*FUNC_0244'!
Return'!FUNC_0244

*FUNC_0245'!
Return'!FUNC_0245

*FUNC_0246'!
Return'!FUNC_0246

*FUNC_0247'!
Return'!FUNC_0247

*FUNC_0248'!
Return'!FUNC_0248

*FUNC_0249'!
Return'!FUNC_0249

*FUNC_0250'!
Return'!FUNC_0250

*FUNC_0251'!
Return'!FUNC_0251

*FUNC_0252'!
Return'!FUNC_0252

*FUNC_0253'!
Return'!FUNC_0253

*FUNC_0254'!
Return'!FUNC_0254

*FUNC_0255'!
Return'!FUNC_0255
'! Command function_End

